#!/usr/bin/wish
#############################################################################
# Visual Tcl v1.10 Project
#

#################################
# GLOBAL VARIABLES
#
global ActBand; set ActBand {2m}
global ActBandbac; set ActBandbac {2m}
global AntExt; set AntExt {0}
global AnzHr; set AnzHr {1.0}
global AnzHrBakInt; set AnzHrBakInt {0}
global AnzHrInt; set AnzHrInt {1}
global AnzOP; set AnzOP {0}
global AnzQSO; set AnzQSO {0}
global Append; set Append {HMM}
global Aurora; set Aurora {0}
global BandChange; set BandChange {0}
global BandList; set BandList {}
global BearingList; set BearingList {}
global CallList; set CallList {}
global CanHeight; set CanHeight {0}
global CanWidth; set CanWidth {0}
global DOK; set DOK {Nr}
global Entfernung; set Entfernung {}
global FileTypes; set FileTypes {{{LogFiles} {.log} TEXT}}
global HeardDat; set HeardDat {.conlogv.hrd}
global HeardList; set HeardList {}
global KMKurve; set KMKurve {}
global LastHRQSONr; set LastHRQSONr {1}
global LocatorList; set LocatorList {}
global LogDat; set LogDat {}
global MaxQSOOP; set MaxQSOOP {0}
global ModeList; set ModeList {}
global MyNordB; set MyNordB {51.4792}
global MyOstL; set MyOstL {7.375}
global NordB; set NordB {}
global NumberList; set NumberList {}
global ODX; set ODX {0}
global ODXCall; set ODXCall {}
global OPDat; set OPDat {}
global Operator; set Operator {MYCALL}
global OstL; set OstL {}
global PI; set PI {3.1415926}
global PointsList; set PointsList {}
global PrefDat; set PrefDat {~/.conlogvrc}
global PtsKurve; set PtsKurve {}
global QSOHRentry; set QSOHRentry {0}
global QSOKurve; set QSOKurve {}
global RSTinList; set RSTinList {}
global RSToutList; set RSToutList {}
global Richtung; set Richtung {}
global RoseFont; set RoseFont {6x10}
global ScaleHR; set ScaleHR {7200.0}
global ScaleKM; set ScaleKM {500.0}
global ScaleOP; set ScaleOP {20.0}
global ScalePts; set ScalePts {1000.0}
global ScaleQSO; set ScaleQSO {20.0}
global StartConTime; set StartConTime {}
global UTCDatum; set UTCDatum {}
global UTCDatumList; set UTCDatumList {}
global UTCList; set UTCList {}
global XOffset; set XOffset {0}
global avbands; set avbands {6m 2m 70cm 23cm 13cm 8cm 5cm 3cm 1.25cm 6.3mm 3.5mm 2.5mm 2mm 1.2mm}
global bandchanged; set bandchanged {TRUE}
global bearingLabel; set bearingLabel {km : ---    Brg : ---}
global bestRateEntry; set bestRateEntry {0}
global boxidx; set boxidx {}
global callLabel; set callLabel {MYCALL}
global callentry; set callentry {}
global colidx; set colidx {0}
global correctLine; set correctLine {FALSE}
global drawn; set drawn {FALSE}
global infoentry; set infoentry {}
global inputentry; set inputentry {}
global kmQSOentry; set kmQSOentry {0}
global lastPointsentry; set lastPointsentry {0}
global lastQSOentry; set lastQSOentry {0}
global listcopied; set listcopied {FALSE}
global locatorentry; set locatorentry {}
global manualUTC; set manualUTC {FALSE}
global modeLabel; set modeLabel {Mode : 2m SSB}
global mylocLabel; set mylocLabel {}
global number; set number {1}
global numberLabel; set numberLabel {Number : 001}
global orange; set orange {#eb0}
global pointsHRentry; set pointsHRentry {0}
global prefAntExt12; set prefAntExt12 {0}
global prefAntExt125; set prefAntExt125 {0}
global prefAntExt13; set prefAntExt13 {0}
global prefAntExt2; set prefAntExt2 {0}
global prefAntExt23; set prefAntExt23 {0}
global prefAntExt25; set prefAntExt25 {0}
global prefAntExt2mm; set prefAntExt2mm {0}
global prefAntExt3; set prefAntExt3 {0}
global prefAntExt35; set prefAntExt35 {0}
global prefAntExt5; set prefAntExt5 {0}
global prefAntExt6; set prefAntExt6 {0}
global prefAntExt63; set prefAntExt63 {0}
global prefAntExt70; set prefAntExt70 {0}
global prefAntExt8; set prefAntExt8 {0}
global prefBandChange; set prefBandChange {0}
global prefDOK; set prefDOK {O54}
global prefSaveDelay; set prefSaveDelay {0}
global preflogpath; set preflogpath {~/}
global prefmode; set prefmode {SSB}
global prefmodebac; set prefmodebac {SSB}
global prefmycall; set prefmycall {MYCALL}
global prefmyloc; set prefmyloc {}
global rot; set rot {#f00}
global rstinentry; set rstinentry {}
global rstoutentry; set rstoutentry {59001}
global saved; set saved {TRUE}
global selectedButton; set selectedButton {}
global ticks; set ticks {60000}
global timeLabel; set timeLabel {}
global totalentry; set totalentry {0}
global utcentry; set utcentry {}
global wait; set wait {FALSE}
global widget; 
    set widget(AboutWin) {.top18}
    set widget(AlertWin) {.top26}
    set widget(BearCanv) {.top19.fra38.fra23.can24}
    set widget(BearingList) {.top19.fra37.fra42.02.03}
    set widget(CallEntry) {.top19.fra36.fra42.ent49}
    set widget(CallList) {.top19.fra37.05.lis40}
    set widget(HelpWin) {.top20}
    set widget(InfoEntry) {.top19.fra38.fra39.fra19.fra20.02}
    set widget(InputEntry) {.top19.fra38.fra39.fra19.fra17.ent19}
    set widget(KMList) {.top19.fra37.fra40.02}
    set widget(LocatorEntry) {.top19.fra36.fra45.ent55}
    set widget(LocatorList) {.top19.fra37.011.lis43}
    set widget(MainWindow) {.top19}
    set widget(ModeList) {.top19.fra37.fra37.lis39}
    set widget(ModeMenu) {.top19.fra24.men26}
    set widget(NumberList) {.top19.fra37.01.lis38}
    set widget(NumberWin) {.top21}
    set widget(OPentry) {.top31.fra32.fra35.ent37}
    set widget(OperatorWin) {.top31}
    set widget(PointsList) {.top19.fra37.fra41.02}
    set widget(PrefMenu) {.top39.fra68.02.men21}
    set widget(PrefWin) {.top39}
    set widget(RSTinEntry) {.top19.fra36.fra44.ent53}
    set widget(RSTinList) {.top19.fra37.09.lis42}
    set widget(RSToutEntry) {.top19.fra36.fra43.ent51}
    set widget(RSToutList) {.top19.fra37.07.lis41}
    set widget(StatFrame) {.top17.fra18}
    set widget(StatKM) {.top17.fra23.can26}
    set widget(StatOP) {.top17.fra18.can20}
    set widget(StatOPFrame) {.top17.fra24}
    set widget(StatPts) {.top17.fra23.can25}
    set widget(StatQSO) {.top17.fra18.can19}
    set widget(StatWin) {.top17}
    set widget(TotalEntry) {.top19.fra56.fra64.ent68}
    set widget(UTCEntry) {.top19.fra36.fra37.ent47}
    set widget(UTCList) {.top19.fra37.03.lis39}
    set widget(numberentry) {.top21.fra22.ent28}
    set widget(rev,.top17) {StatWin}
    set widget(rev,.top17.fra18) {StatFrame}
    set widget(rev,.top17.fra18.can19) {StatQSO}
    set widget(rev,.top17.fra18.can20) {StatOP}
    set widget(rev,.top17.fra23.can25) {StatPts}
    set widget(rev,.top17.fra23.can26) {StatKM}
    set widget(rev,.top17.fra24) {StatOPFrame}
    set widget(rev,.top17.fra24.can27) {StatOPCan}
    set widget(rev,.top18) {AboutWin}
    set widget(rev,.top19) {MainWindow}
    set widget(rev,.top19.fra24.men26) {ModeMenu}
    set widget(rev,.top19.fra36.fra37.ent47) {UTCEntry}
    set widget(rev,.top19.fra36.fra42.ent49) {CallEntry}
    set widget(rev,.top19.fra36.fra43.ent51) {RSToutEntry}
    set widget(rev,.top19.fra36.fra44.ent53) {RSTinEntry}
    set widget(rev,.top19.fra36.fra45.ent55) {LocatorEntry}
    set widget(rev,.top19.fra37.01.lis38) {NumberList}
    set widget(rev,.top19.fra37.011.lis43) {LocatorList}
    set widget(rev,.top19.fra37.015.lis46) {PointsList}
    set widget(rev,.top19.fra37.03.lis39) {UTCList}
    set widget(rev,.top19.fra37.05.lis40) {CallList}
    set widget(rev,.top19.fra37.07.lis41) {RSToutList}
    set widget(rev,.top19.fra37.09.lis42) {RSTinList}
    set widget(rev,.top19.fra37.fra37.lis39) {ModeList}
    set widget(rev,.top19.fra37.fra41.02) {PointsList}
    set widget(rev,.top19.fra37.fra42.02.03) {BearingList}
    set widget(rev,.top19.fra38.fra23.can24) {BearCanv}
    set widget(rev,.top19.fra38.fra39.fra19.fra17.ent19) {InputEntry}
    set widget(rev,.top19.fra38.fra39.fra19.fra20.02) {InfoEntry}
    set widget(rev,.top19.fra56.fra17.ent21) {InputEntry}
    set widget(rev,.top19.fra56.fra18.02) {InfoEntry}
    set widget(rev,.top19.fra56.fra62.ent69) {InfoEntry}
    set widget(rev,.top19.fra56.fra64.ent68) {TotalEntry}
    set widget(rev,.top20) {HelpWin}
    set widget(rev,.top21) {NumberWin}
    set widget(rev,.top21.fra22.ent28) {numberentry}
    set widget(rev,.top26) {AlertWin}
    set widget(rev,.top31) {OperatorWin}
    set widget(rev,.top31.fra32.fra35.ent37) {OPentry}
    set widget(rev,.top39) {PrefWin}
    set widget(rev,.top39.fra68.02.men21) {PrefMenu}
global withdrawn; set withdrawn {FALSE}

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {

}

init $argc $argv


proc AddOP {} {
global widget OPKurve Operator callLabel AnzOP color colidx

set Operator [string toupper $Operator]
set callLabel $Operator
set utc [CutTimeMinute [clock seconds]]

incr AnzOP
incr colidx
set anzcol [array size color]

if {$colidx>$anzcol} {
    set colidx 1
}

set idx 0
set anz [array size OPKurve]
for {set i 1} {$i<=$anz} {incr i} {
    set op [lindex $OPKurve($i) 0]
    if {$op==$Operator} {
        set idx [lindex $OPKurve($i) 4]
    }
}

set urahn [expr $AnzOP - 1]
if {$urahn>0} {
    set OPKurve($urahn) [lreplace $OPKurve($urahn) 2 2 $utc]
}
if {$idx>0} {
    set OPKurve($AnzOP) "$Operator $utc $utc 0 $idx"
    incr colidx -1
} else {
    set OPKurve($AnzOP) "$Operator $utc $utc 0 $colidx"
}

Window hide $widget(OperatorWin)

ReScaleStatWin
UpdateStatWin FALSE
}

proc AddQSOOP {idx} {
global OPKurve MaxQSOOP

set utc [CutTimeMinute [clock seconds]]
set anz [lindex $OPKurve($idx) 3]
incr anz
set OPKurve($idx) [lreplace $OPKurve($idx) 2 3 $utc $anz]
if {$MaxQSOOP<$anz} {
    set MaxQSOOP $anz
}
}

proc ArcGCOS {win} {
global PI

    if {$win>=1} {
	return 0.0
    } elseif {$win<=-1} {
	return 180.0
    } else {
	set arcbog [expr $PI/2.0-atan($win/(sqrt(1.0-pow($win,2))))]
        return [expr $arcbog*180.0/$PI]
    }
}

proc BandChangeTimer {} {
global BandChange prefBandChange bandchanged orange

if {$BandChange<$prefBandChange && $prefBandChange>0} {
    incr BandChange
    after 60000 {BandChangeTimer}
} elseif {$BandChange==$prefBandChange && $prefBandChange>0} {
    set BandChange 0
    DisplayInfo "BandChange now allowed !!!" $orange 1 3000
}
set bandchanged FALSE
}

proc CalBestRateFromLog {} {
global bestRateEntry UTCList UTCDatumList PointsList

set BestRateBac 0
set Anzahl [llength $UTCList]
set i 0
set QSOTime 0

while {$i < $Anzahl && $QSOTime!=""} {
    set idx $i
    set BestRate 0

    set QSOTime [lindex $UTCList $i]
    set start [ReConstructTime $i]

    set end [expr $start + 3600]

    while {$start<=$end && $QSOTime!=""} {
        incr BestRate
        incr idx
        if {$BestRateBac<$BestRate && [lindex $PointsList $idx]>0} {
            set BestRateBac $BestRate
        }
        set QSOTime [lindex $UTCList $idx]
        set start [ReConstructTime $idx]
    }
    incr i
}
set bestRateEntry $BestRateBac
}

proc CalHours {} {
global AnzHr AnzHrInt StartConTime

####### Anzahl der Stunden seit Beginn des Contestes
set utc [CutTimeMinute [clock seconds]]
set AnzHr [expr ($utc - $StartConTime) / 3600.0]
if {$AnzHr<1.0} {
    set AnzHr 1.0
}

set AnzHrInt [expr $AnzHr - int($AnzHr)]
if {$AnzHrInt>0} {
    set AnzHrInt [expr int($AnzHr) + 1]
} else {
    set AnzHrInt 1
}
}

proc CalTimer {} {
global AnzQSO LastHRQSONr PointsList 
global bestRateEntry pointsHRentry QSOHRentry kmQSOentry lastQSOentry 
global lastPointsentry totalentry kmQSOentry AnzHr

CalHours
if {$AnzQSO>0} {
    set utc [clock seconds]
    set lastutc [expr $utc - 3600]
    set Anzahl [llength $PointsList]

    ####### letztes QSO vor einer Stunde berechnen
    set idx [expr $LastHRQSONr - 1]
    set QSOTime [ReConstructTime $idx]

    while {$lastutc>$QSOTime && $idx<$Anzahl} {
        incr idx
        set QSOTime [ReConstructTime $idx]
    }
    set LastHRQSONr [expr $idx + 1]

    ######## km/QSO
    if {$AnzQSO>0} {
        set kmQSOentry [expr $totalentry / $AnzQSO]
    }

    ######## Points/hour
    set pointsHRentry [expr round($totalentry / $AnzHr)]

    ######## QSO/hour
    set QSOHRentry [expr round($AnzQSO / $AnzHr)]

    ######## Points/QSO
    set kmQSOentry [expr $totalentry / $AnzQSO]

    ######## Points + QSOsder letzten Stunde
    set LastHRAnzQSO 0
    set lastPoints 0
    for {set i $idx} {$i < $Anzahl} {incr i} {
        set points [lindex $PointsList $i]
        set lastPoints [expr $points + $lastPoints]
        if {$points>0} {
            incr LastHRAnzQSO
        }    
    }
    set lastPointsentry $lastPoints
    set lastQSOentry $LastHRAnzQSO

    ######## Best QSO-Rate
    if {$bestRateEntry<$lastQSOentry} {
        set bestRateEntry $lastQSOentry
    }
}
after 10000 {CalTimer}
}

proc ChangeModeBand {} {
global ActBand prefmode modeLabel correctLine bandchanged
global prefmodebac ActBandbac prefBandChange prefAntExt2 
global prefAntExt6 prefAntExt70 prefAntExt23 prefAntExt13 prefAntExt8 prefAntExt5 prefAntExt3 
global prefAntExt125 prefAntExt63 prefAntExt35 prefAntExt25 prefAntExt2mm 
global prefAntExt12 AntExt

if {$correctLine=="FALSE"} {
    set timed [CheckBandTimer]
    if {($timed=="TRUE" || $prefBandChange==0) && $ActBandbac!=$ActBand} {
        set modeLabel "Mode : $ActBand $prefmode"
        CopyList2ListBox
        set prefmodebac $prefmode
        set ActBandbac $ActBand
        set bandchanged TRUE
    } elseif {$timed=="FALSE" && $prefBandChange>0} {
        set bandchanged FALSE
        set prefmode $prefmodebac
        set ActBand $ActBandbac
    }
} else {
    set modeLabel "Mode : $ActBand $prefmode"
}
case $ActBand {
    "6m"      {set AntExt $prefAntExt6}
    "2m"      {set AntExt $prefAntExt2}
    "70cm"    {set AntExt $prefAntExt70}
    "23cm"    {set AntExt $prefAntExt23}
    "13cm"    {set AntExt $prefAntExt13}
    "8cm"     {set AntExt $prefAntExt8}
    "5cm"     {set AntExt $prefAntExt5}
    "3cm"     {set AntExt $prefAntExt3}
    "1.25cm"  {set AntExt $prefAntExt125}
    "6.3mm"   {set AntExt $prefAntExt63}
    "3.5mm"   {set AntExt $prefAntExt35}
    "2.5mm"   {set AntExt $prefAntExt25}
    "2mm"     {set AntExt $prefAntExt2mm}
    "1.2mm"   {set AntExt $prefAntExt12}
}
}

proc CheckBandTimer {} {
global BandChange prefBandChange rot orange

if {$BandChange>0 && $prefBandChange>0} {
    DisplayInfo "BandChange allowed in : [expr $prefBandChange - $BandChange] min !!!" $rot 1 3000
    return FALSE
} elseif {$BandChange==0 && $prefBandChange>0} {
    DisplayInfo "BandChange now allowed !!!" $orange 1 3000
    return TRUE
}
}

proc CheckDouble {} {
global callentry correctLine number locatorentry rstinentry rot CallList BandList ActBand

set call $callentry
set res1 [regexp {^([A-Z0-9]+/)[^(P|M|MM|AM)]} $call {} preprefix]
set res2 [regexp {(/(P|M|MM|AM))$} $call postfix]
set res3 [regexp {^([A-Z0-9]+/[A-Z0-9]+)(/(P|M|MM|AM))$} $call]

if {$res3==1} {
    regsub {^([A-Z0-9]+/)} $call "" call
    regsub {(/(P|M|MM|AM))$} $call "" call
} else {
    if {$res1==1} {
        regsub {^([A-Z0-9]+/)} $call "" call
    } elseif {$res2==1} {
        regsub {(/(P|M|MM|AM))$} $call "" call
    }
}
set idx [expr $number - 1]
set Anzahl [llength $CallList]
for {set i 0} {$i < $Anzahl} {incr i} {
    if {$i!=$idx || $correctLine!="TRUE"} {
        set ListCall [lindex $CallList $i]
        set band [lindex $BandList $i]
        set res4 [regexp {^([A-Z0-9]+/)[^(P|M|MM|AM)]} $ListCall]
        set res5 [regexp {(/(P|M|MM|AM))$} $ListCall]
        set res6 [regexp {^([A-Z0-9]+/[A-Z0-9]+)(/(P|M|MM|AM))$} $ListCall]
        if {$res6==1} {
            regsub {^([A-Z0-9]+/)} $ListCall "" ListCall
            regsub {(/(P|M|MM|AM))$} $ListCall "" ListCall
        } else {
            if {$res4==1} {
                regsub {^([A-Z0-9]+/)} $ListCall "" ListCall
            } elseif {$res5==1} {
                regsub {(/(P|M|MM|AM))$} $ListCall "" ListCall
            }
        }
        if {$ListCall == $call && $ActBand==$band} {
            set callentry {}
            set locatorentry {}
            set rstinentry {}
            DisplayInfo "Double !!!" $rot 3 3000
            return "TRUE"
        }
    }
}
}

proc CheckEntries {} {
global widget number correctLine numberLabel locatorentry totalentry
global prefmodebac utcentry callentry rstoutentry rstinentry
global inputentry prefmode modeLabel Richtung boxidx AnzOP AnzQSO
global bandchanged Entfernung

    set inputentry {}
    if {$utcentry!="" && $callentry!="" && $rstoutentry>"11000" && $rstinentry>"11000" && $locatorentry!=""} {
        WaitReturn
        if {$inputentry!=""} {
            EvalInput
        }
        if {$utcentry!="" && $callentry!="" && $rstoutentry>"11000" && $rstinentry>"11000" && $locatorentry!=""} {
            set idx [expr $number - 1]
            if {$correctLine=="TRUE"} {
                if {$Entfernung==0} {
                    GetBearDist
                    incr AnzQSO
                    ReplaceQSOOP $idx FALSE
                }
                ReplaceOneList $idx
                DelOneListBoxes $boxidx
                FillListBoxes $boxidx $idx
                SaveLine $idx
            } else {
                set endidx [$widget(NumberList) size]
                incr AnzQSO
                AddQSOOP $AnzOP
                FillList $idx $number
                FillListBoxes $endidx $idx
                SaveLine $idx
                ViewLastLineListBoxes
                if {$bandchanged=="TRUE"} {
                    BandChangeTimer
                }
            }
            CheckODX $Entfernung $callentry TRUE
            set totalentry [expr $totalentry + $Entfernung]
            NextEntries
            SaveOP
            focus $widget(InputEntry)
        }
    }
}

proc CheckHeard {call} {
########## Checks if Calls are preheard or have changed
global HeardList locatorentry

if {$locatorentry==""} {
    foreach i $HeardList {
        if {[lindex $i 0] == $call} {
            set locatorentry [lindex $i 1]
            CheckNewLocator $locatorentry
        }
    }
} else {
    set j 0
    set double 0
    foreach i $HeardList {
        if {[lindex $i 0]==$call && [lindex $i 1]!=$locatorentry} {
            set HeardList [lreplace $HeardList $j $j "$call $locatorentry"]
            set double 1
        }
        incr j
    }
    if {$double==0} {
        lappend HeardList "$call $locatorentry"
    }
}
}

proc CheckMode {num} {
global modeLabel ActBand prefmode Aurora rstoutentry rstinentry 
global DOK prefDOK

set modeLabel "Mode : $ActBand $prefmode"
set rstinentry {}
if {$Aurora==1} {
    if {$DOK=="DOK" && $prefDOK!=""} {
        set rstoutentry "59a$prefDOK"
    } elseif {$DOK=="NrDOK" && $prefDOK!=""} {
       set rstoutentry "59a$num$prefDOK"
    } else {
        set rstoutentry "59a$num"
    }
} else {
    if {$prefmode=="CW" || $prefmode=="RTTY"} {
        if {$DOK=="DOK" && $prefDOK!=""} {
            set rstoutentry "599$prefDOK"
        } elseif {$DOK=="NrDOK" && $prefDOK!=""} {
           set rstoutentry "599$num$prefDOK"  
        } else {
            set rstoutentry "599$num"
        }
    } else {
        if {$DOK=="DOK" && $prefDOK!=""} {
            set rstoutentry "59$prefDOK"
        } elseif {$DOK=="NrDOK" && $prefDOK!=""} {
           set rstoutentry "59$num$prefDOK"  
        } else {        
            set rstoutentry "59$num"
        }
    }
}
}

proc CheckNewLocator {loc} {
global orange LocatorList

set new 0
set res [regexp {^([A-R][A-R][0-9][0-9])} $loc {} KF]

set Anzahl [llength $LocatorList]
for {set i 0} {$i < $Anzahl} {incr i} {
    set listloc [lindex $LocatorList $i]
    if {$listloc!="XXXXX"} {
        set res1 [regexp {^([A-R][A-R][0-9][0-9])} $listloc {} ListKF]
        if {$KF==$ListKF} {
            set new 1
        }
    } else {
        set new 1
    }
}
if {$new==0} {
    DisplayInfo "New Square !" $orange 1 3000
    return TRUE
} else {
    return FALSE
}
}

proc CheckODX {range call inform} {
global ODX ODXCall orange correctLine 
global PointsList CallList

if {$correctLine=="TRUE" && $ODXCall==$call} {
    if {$ODX<$range} {
        set ODX $range
        set ODXCall $call
    } else {
        set ODX {}
        set ODXCall {}
        set Anzahl [llength $PointsList]
        for {set i 0} {$i<$Anzahl} {incr i} {
            set dumodx [lindex $PointsList $i]
            set dumcall [lindex $CallList $i]
            if {$call==$dumcall} {
                if {$range>$ODX} {
                    set ODX $range
                    set ODXCall $call
                }
            } else {
                if {$dumodx>$ODX} {
                    set ODX $dumodx
                    set ODXCall $dumcall
                }
            }
        }
    }
} elseif {$range>$ODX} {
    set ODX $range
    set ODXCall $call
    if {$inform=="TRUE"} {
        DisplayInfo "ODX !!!" $orange 1 3000
    }
}
}

proc CopyLine {idx} {
global widget numberLabel utcentry callentry rstoutentry rstinentry
global locatorentry number correctLine UTCDatum manualUTC rot
global modeLabel ActBand prefmode ActBandbac prefmodebac
global totalentry Entfernung Richtung boxidx
global NumberList UTCList CallList RSToutList UTCDatumList
global RSTinList LocatorList BandList ModeList PointsList BearingList

if {$idx!=""} {
    set manualUTC TRUE
    set ActBandbac $ActBand
    set prefmodebac $prefmode
    $widget(NumberList) selection set $idx
    set boxidx $idx

    set number [$widget(NumberList) get $idx]
    set listidx [expr $number - 1]

    set utcentry [lindex $UTCList $listidx]
    set callentry [lindex $CallList $listidx]
    set rstoutentry [lindex $RSToutList $listidx]
    set rstinentry [lindex $RSTinList $listidx]
    set locatorentry [lindex $LocatorList $listidx]
    set ActBand [lindex $BandList $listidx]
    set prefmode [lindex $ModeList $listidx]
    set UTCDatum [lindex $UTCDatumList $listidx]
    set Richtung [lindex $BearingList $listidx]
    set Entfernung [lindex $PointsList $listidx]

    set num [TranslateNumber $number]
    set numberLabel "Number : $num"
    set modeLabel "Mode : $ActBand $prefmode"
    set totalentry [expr $totalentry - $Entfernung]

    set correctLine TRUE
    SetBearing $Richtung $Entfernung
    DisplayInfo "Entered Correction Mode !!!" $rot 1 0
    focus $widget(InputEntry)
}
}

proc CopyList2ListBox {} {
global widget NumberList UTCList CallList RSToutList listcopied ActBand
global RSTinList LocatorList BandList ModeList PointsList BearingList

DelAllListBoxes
set Anzahl [llength $NumberList]
for {set i 0} {$i < $Anzahl} {incr i} {
    set band [lindex $BandList $i]
    if {$ActBand==$band} {
        $widget(NumberList) insert end [lindex $NumberList $i]
        $widget(UTCList) insert end [lindex $UTCList $i]
        $widget(CallList) insert end [lindex $CallList $i]
        $widget(RSToutList) insert end [lindex $RSToutList $i]
        $widget(RSTinList) insert end [lindex $RSTinList $i]
        $widget(LocatorList) insert end [lindex $LocatorList $i]
        $widget(ModeList) insert end [lindex $ModeList $i]
        $widget(PointsList) insert end [lindex $PointsList $i]
        $widget(BearingList) insert end [lindex $BearingList $i]
    }
}
ViewLastLineListBoxes
set listcopied FALSE
}

proc CreateColors {} {
global color

set color(1) #fb0
set color(2) #0d0
set color(3) #0df
set color(4) #f0f
set color(5) #aaa
set color(6) #fff
set color(7) #ff0
set color(8) #0ff
set color(9) #e88
set color(10) #55f
}

proc CutTimeMinute {secs} {
set secs [clock format $secs -format "%d %b %Y %H%M" -gmt true]
return [clock scan $secs -gmt TRUE]
}

proc DelAllListBoxes {} {
global widget

$widget(NumberList) delete 0 end
$widget(UTCList) delete 0 end
$widget(CallList) delete 0 end
$widget(RSToutList) delete 0 end
$widget(RSTinList) delete 0 end
$widget(LocatorList) delete 0 end
$widget(ModeList) delete 0 end
$widget(PointsList) delete 0 end
$widget(BearingList) delete 0 end
}

proc DelAllLists {} {
global NumberList UTCList UTCDatumList CallList RSToutList RSTinList
global LocatorList BandList ModeList PointsList BearingList

set NumberList {}
set UTCList {}
set UTCDatumList {}
set CallList {}
set RSToutList {}
set RSTinList {}
set LocatorList {}
set BandList {}
set ModeList {}
set PointsList {}
set BearingList {}
}

proc DelBearCanv {} {
global widget bearingLabel drawn

set bearingLabel "km : ---    Brg : ---"
$widget(BearCanv) delete Direct
update
set drawn FALSE
}

proc DelEntries {num} {
global callentry rstinentry inputentry locatorentry

selection clear
set callentry {}
CheckMode $num
set rstinentry {}
set locatorentry {}
set inputentry {}
DelBearCanv
}

proc DelOneList {idx} {
global UTCDatumList UTCList NumberList CallList 
global BandList BearingList RSToutList RSTinList 
global LocatorList ModeList PointsList saved 

if {$idx!=""} {
    set NumberList [lreplace $NumberList $idx $idx]
    set UTCList [lreplace $UTCList $idx $idx]
    set UTCDatumList [lreplace $UTCDatumList $idx $idx]
    set CallList [lreplace $CallList $idx $idx]
    set RSToutList [lreplace $RSToutList $idx $idx]
    set RSTinList [lreplace $RSTinList $idx $idx]
    set LocatorList [lreplace $LocatorList $idx $idx]
    set BandList [lreplace $BandList $idx $idx]
    set ModeList [lreplace $ModeList $idx $idx]
    set PointsList [lreplace $PointsList $idx $idx]
    set BearingList [lreplace $BearingList $idx $idx]

    set saved "FALSE"
}
}

proc DelOneListBoxes {idx} {
global widget

if {$idx!=""} {
    $widget(NumberList) delete $idx
    $widget(UTCList) delete $idx
    $widget(CallList) delete $idx
    $widget(RSToutList) delete $idx
    $widget(RSTinList) delete $idx
    $widget(LocatorList) delete $idx
    $widget(ModeList) delete $idx
    $widget(PointsList) delete $idx
    $widget(BearingList) delete $idx
}
}

proc DelStatEntries {} {
global LastHRQSONr StartConTime bestRateEntry totalentry
global pointsHRentry QSOHRentry kmQSOentry lastQSOentry lastPointsentry
global ODX ODXCall

set totalentry 0
set ODX 0
set ODXCall {}
set pointsHRentry 0
set kmQSOentry 0
set QSOHRentry 0
set bestRateEntry 0
set lastQSOentry 0
set lastPointsentry 0
set LastHRQSONr 1
set StartConTime [CutTimeMinute [clock seconds]]
}

proc DisplayCallsLocs {} {
global widget inputentry NumberList UTCList CallList RSToutList 
global RSTinList LocatorList ModeList PointsList BearingList 
global callentry locatorentry listcopied

DelAllListBoxes
set inputentry [string toupper $inputentry]

set Anzahl [llength $NumberList]
for {set i 0} {$i < $Anzahl} {incr i} {
    set res [string match *$inputentry* [lindex $CallList $i]]
    set res1 [string match *$inputentry* [lindex $LocatorList $i]]
    if {$locatorentry!=""} {
        set res2 [string match *$locatorentry* [lindex $LocatorList $i]]
    } else {
        set res2 0
    }
    if {$callentry!=""} {
        set res3 [string match *$callentry* [lindex $CallList $i]]
    } else {
        set res3 0
    }
    if {$res==1 || $res1==1 || $res2==1 || $res3==1} {
        $widget(NumberList) insert end [lindex $NumberList $i]
        $widget(UTCList) insert end [lindex $UTCList $i]
        $widget(CallList) insert end [lindex $CallList $i]
        $widget(RSToutList) insert end [lindex $RSToutList $i]
        $widget(RSTinList) insert end [lindex $RSTinList $i]
        $widget(LocatorList) insert end [lindex $LocatorList $i]
        $widget(ModeList) insert end [lindex $ModeList $i]
        $widget(PointsList) insert end [lindex $PointsList $i]
        $widget(BearingList) insert end [lindex $BearingList $i]
    }
}
set listcopied TRUE
}

proc DisplayInfo {text farbe bellcount dauer} {
global widget infoentry anzbell

    set anzbell $bellcount
    set infoentry $text
    $widget(InfoEntry) configure -bg $farbe
    update
    if {$anzbell>0} {
        after 1 {
            for {set i 0} {$i<$anzbell} {incr i} {
                after 200
                bell
            }
        }
    }
    if {$dauer!=0} {
        after $dauer {ResetInfo}
    }
}

proc DisplayNumberWin {} {
global widget

Window show $widget(NumberWin)
focus $widget(numberentry)
$widget(numberentry) selection range 0 end
}

proc DisplayOPWin {} {
global widget

Window show $widget(OperatorWin)
focus $widget(OPentry)
$widget(OPentry) selection range 0 end
}

proc DisplayRose {} {
global widget RoseFont

$widget(BearCanv) create oval 15 10 135 57 -tags Rose
$widget(BearCanv) create text 75 6 -text "N" -font $RoseFont -tags Rose
$widget(BearCanv) create text 75 65 -text "S" -font $RoseFont -tags Rose
$widget(BearCanv) create text 7 35 -text "W" -font $RoseFont -tags Rose
$widget(BearCanv) create text 143 35 -text "O" -font $RoseFont -tags Rose
}

proc DisplayStatWin {} {
global widget CanWidth CanHeight 

Window show $widget(StatWin)
update
bind $widget(StatQSO) <Configure> {
    set CanWidth [expr %w - 20]
    set CanHeight [expr %h - 20]
    ReScaleStatWin
    UpdateStatWin FALSE
}
set CanWidth [winfo width $widget(StatFrame)]
set CanHeight [winfo height $widget(StatFrame)]
set CanWidth [expr ($CanWidth / 2) - 20]
incr CanHeight -20
ReScaleStatWin
UpdateStatWin FALSE
}

proc EditLineWithKey {} {
global widget

ViewLastLineListBoxes
$widget(NumberList) selection set end
$widget(NumberList) activate end
focus $widget(NumberList)
}

proc Entf_Richt {O1 N1 O2 N2} {
global PI Entfernung Richtung

    set SinO1 [GSIN $O1]
    set SinN1 [GSIN $N1]
    set SinO2 [GSIN $O2]
    set SinN2 [GSIN $N2]
    set CosN1 [GCOS $N1]
    set CosN2 [GCOS $N2]
    set O2O1 [expr $O2 - $O1]
    set CosO2O1 [GCOS $O2O1]
    set SinO2O1 [GSIN $O2O1]

    # Entfernungsberechnung
    set dum [expr $SinN1*$SinN2+$CosN1*$CosN2 * $CosO2O1]
    set EW [ArcGCOS $dum]
    set Entfernung [expr 40009.0/360.0*$EW]
    set Entfernung [expr round($Entfernung)]

    # Richtungsberechnung
    set SinEW [GSIN $EW]
    set CosEW [GCOS $EW]

    set dum [expr ($SinN2 - $SinN1 * $CosEW) / ($CosN1 * $SinEW)]
    set RV [ArcGCOS $dum]

    if {$SinO2O1>=0.0} {
	set Richtung [expr round($RV)]
    }
    if {$SinO2O1<0.0} {
	set Richtung [expr 360.0-$RV]
        set Richtung [expr round($Richtung)]
    }
}

proc EvalCall {} {
global widget callentry Entfernung

if {$callentry!=""} {
    selection clear
    set callentry [string toupper $callentry]
    regsub {#$} $callentry "/P" callentry
    regsub {\+$} $callentry "/MM" callentry
    regsub {\-$} $callentry "/M" callentry
    regsub {\<$} $callentry "/AM" callentry
    set len [string length $callentry]
    if {$len>13} {
	set callentry {}
    } else {
	set res [regexp {^([A-Z0-9]+/)?[A-Z0-9]+(/(P|M|MM|AM))?$} $callentry]
	if {$res!=1} {
	    set callentry {}
            focus $widget(CallEntry)
	} else {
	    
            focus $widget(InputEntry)
            set bool [CheckDouble]
            if {$bool!="TRUE"} {
                CheckHeard $callentry
                GetBearDist
            }
	}
    }
} else {
    set callentry {}
    focus $widget(CallEntry)
}
}

proc EvalInput {} {
global widget inputentry locatorentry number UTCDatum prefmode
global rstoutentry rstinentry callentry utcentry manualUTC Aurora
global DOK prefDOK rot

if {$inputentry==""} {
    focus $widget(InputEntry)
} else {
    selection clear
    set len [string length $inputentry]
    set not 0
    set newloc FALSE

    ##### UTC
    if {$not==0} {
        set res [regexp {^([01]?[0-9]|2[0-3])?:([0-5]?[0-9]?)$} $inputentry]
        if {$res==1} {
            set manualUTC TRUE
            set utcentry [ValiDatum $inputentry]
            set utc [clock seconds]
            set UTCDatum [clock format $utc -format "%a,%d.%b.%Y" -gmt true]
            set not 1
        }
    }
    
    ###### RSTout
    if {$not==0} {
        set inputentry [string tolower $inputentry]
        set num [TranslateNumber $number]
        set res1 [regexp {^([1-5][1-9][1-9][cx]?)$} $inputentry]
        set res2 [regexp {^([1-5][1-9])$} $inputentry]
        if {$inputentry>10} {
            if {$Aurora==0} {
                if {(($prefmode=="CW" || $prefmode=="RTTY") && $res1==1) || ($prefmode!="CW" && $prefmode!="RTTY" && $res2==1)} {
                    if {$DOK=="DOK" && $prefDOK!=""} {
                        set num "$prefDOK"
                    } elseif {$DOK=="NrDOK" && $prefDOK!=""} {
                        set num "$num$prefDOK"
                    }
                    set rstoutentry "$inputentry$num"
                    set not 1
                }
            } else {
                if {$res2==1} {
                    if {$DOK=="DOK" && $prefDOK!=""} {
                       set num "a$num"
                    } elseif {$DOK=="NrDOK" && $prefDOK!=""} {
                        set num "a$num$prefDOK"
                    }
                    set rstoutentry "$inputentry$num"
                    set not 1
                }
            }
        }
    }

    ###### RSTin
    if {$not==0} {
        set inputentry [string tolower $inputentry]
        set test $inputentry
        set res1 [regexp {^[1-5][1-9][0-9][0-9][0-9]+$} $inputentry]
        set res2 [regexp {^[1-5][1-9]a?[0-9][0-9][0-9]+$} $inputentry]
        set res3 [regexp {^[1-9][1-9]a?[a-z0-9][a-z0-9][a-z0-9]+$} $inputentry]

        set res4 [regexp {^[1-5][1-9][1-9][xc]?[0-9][0-9][0-9]+$} $inputentry]
        set res6 [regexp {^[1-5][1-9][1-9][xc]?[a-z0-9][a-z0-9][a-z0-9]+$} $inputentry]
        set dok1 [regexp {^D[ABCDFGHJKLMNOP]} $callentry]
        
        if {$Aurora==0} {
            if {($prefmode=="CW" || $prefmode=="RTTY") && ($res4==1 || $res6==1)} {
                if {$res6==1 && $DOK!="Nr"} {
                    regexp {^([1-5][1-9][1-9][xc]?)} $test {} rst
                    regsub {^([1-5][1-9][1-9][xc]?)} $test {} test
                    set test [string toupper $test]
                    set rstinentry $rst$test
                    set not 1
                } elseif {$res4==1} {
                    regsub {[cx]} $inputentry "" test
                    if {$test==""} {set test $inputentry}
                    set rest [expr $test%10000]
                    if {$rest!=0} {
                        set rstinentry $inputentry
                        set not 1 
                    }
                }
            } elseif {($prefmode!="CW" && $prefmode!="RTTY") && ($res1==1 || $res3==1)} {
                if {$res3==1 && $DOK!="Nr"} {
                    regexp {^([1-5][1-9])} $test {} rst
                    regsub {^([1-5][1-9])} $test {} test
                    set test [string toupper $test]
                    set rstinentry $rst$test
                    set not 1
                } elseif {$res1==1} {
                    set rest [expr $inputentry%1000]
                    if {$rest!=0} {
                        set rstinentry $inputentry
                        set not 1 
                    }
                }
            }
        } else {
            regsub {a} $inputentry "" test
            if {$res2==1} {
                set rest [expr $test%1000]
                if {$rest!=0} {
                    regexp {^([1-5][1-9])} $test {} rst
                    regsub {^([1-5][1-9])} $test {} test
                    set test "a$test"
                    set rstinentry "$rst$test"
                    set not 1 
                }
            } elseif {$res3==1 && $DOK!="Nr"} {
                regexp {^([1-5][1-9])} $test {} rst
                regsub {^([1-5][1-9])} $test {} test
                set test [string toupper $test]
                set test "a$test"
                set rstinentry "$rst$test"
                set not 1
            }
        }
        if {$DOK=="DOK" || $DOK=="NrDOK"} {
            if {$dok1==1 && ($res2==1 || $res4==1)} {
                DisplayInfo "No DOK ?" $rot 1 3000
            } elseif {$dok1==0 && ($res3==1 || $res6==1) && ($res2==0 && $res4==0)} {
                DisplayInfo "Valid incoming Rapport ?" $rot 1 3000
            }
        } 
    }

    ##### Locator
    if {$not==0} {
        set inputentry [string toupper $inputentry]
        set res [regexp {^[A-R][A-R][0-9][0-9][A-X][A-X]$} $inputentry]
        if {$res==1 && $len==6} {
            set locatorentry $inputentry
            GetBearDist
            set newloc [CheckNewLocator $locatorentry]
            if {$newloc!="TRUE"} {
                DisplayCallsLocs
            }
            if {$callentry!=""} {
                CheckHeard $callentry
            }
            set not 1
        }
    }

    ####### Call
    if {$not==0} {
        set inputentry [string toupper $inputentry]
        if {$len<=13} {
            set preprefix {}
            regsub {#$} $inputentry "/P" inputentry
	    regsub {\+$} $inputentry "/MM" inputentry
	    regsub {\-$} $inputentry "/M" inputentry
            regsub {\<$} $inputentry "/AM" inputentry
            ##### Toggle /p /mm /m /am
            set res [regexp {^((([A-Z]([A-Z]|[0-9]))|([0-9][A-Z])|[A-Z])[0-9]?[A-Z]?[A-Z]?[A-Z]?/)$|^(/(P|M|MM|AM))$} $inputentry]
            if {$res==1} {
                set res2 [regexp {^([A-Z0-9]+/)$} $inputentry]
                set res3 [regexp {^(/(P|M|MM|AM))$} $inputentry]
                set res4 [regexp {^([A-Z0-9]+/)} $callentry {} preprefix]
                set res5 [regexp {(/(P|M|MM|AM))$} $callentry postfix]
                set res6 [regexp {^([A-Z0-9]+/[A-Z0-9]+)(/(P|M|MM|AM))$} $callentry]
                if {$res2==1} {
                    if {$res4==0} {
                        set callentry "$inputentry$callentry"
                    } else {
                        if {$res6==0} {
                            if {$res5==0} {
                                if {$preprefix==$inputentry} {
                                    regsub {^([A-Z0-9]+/)} $callentry "" callentry
                                } else {
                                    regsub {^([A-Z0-9]+/)} $callentry $inputentry callentry
                                }
                            } else {
                                if {$preprefix!=$inputentry} {
                                    set callentry "$inputentry$callentry"
                                }
                            }
                        } else {
                            if {$preprefix==$inputentry} {
                                regsub {^([A-Z0-9]+/)} $callentry "" callentry
                            } else {
                                regsub {^([A-Z0-9]+/)} $callentry $inputentry callentry
                            }
                        }
                    }
                } elseif {$res3==1} {
                    if {$res5==1} {
                        if {$postfix==$inputentry} {
                            regsub {(/(P|MM|M|AM))$} $callentry "" callentry
                        } else {
                            regsub {(/(P|MM|M|AM))$} $callentry $inputentry callentry
                        }
                    } elseif {$res5==0} {
                        set callentry "$callentry$inputentry"
                    }
                }
            } else {
                ##### Insert Call
                if {$len>=3} {
		    set res [regexp {^((([A-Z]([A-Z]|[0-9]))|([0-9][A-Z])|[A-Z])[0-9]?[A-Z]?[A-Z]?[A-Z]?/)?((([A-Z]([A-Z]|[0-9]))|([0-9][A-Z])|[A-Z])[0-9][A-Z][A-Z]?[A-Z]?)(/(P|M|MM|AM))?$} $inputentry]
                    if {$res==1} {
                        if {$DOK==1} {
                            set dok2 [regexp {^[1-5][1-9]a?[0-9][0-9][0-9]+$} $rstinentry]
                            set dok3 [regexp {^[1-9][1-9]a?[A-Z0-9][A-Z0-9][A-Z0-9]+$} $rstinentry]
    
                            set dok4 [regexp {^[1-5][1-9][1-9][xc]?[0-9][0-9][0-9]+$} $rstinentry]
                            set dok6 [regexp {^[1-5][1-9][1-9][xc]?[A-Z0-9][A-Z0-9][A-Z0-9]+$} $rstinentry]
                            set res1 [regexp {^D[ABCDFGHJKLMNOP]} $inputentry]
                            if {$res1==1 && ($dok2==1 || $dok4==1)} {
                                DisplayInfo "No DOK ?" $rot 1 3000
                            } elseif {$res1==0 && ($dok3==1 || $dok6==1) && ($dok2==0 && $dok4==0)} {
                                DisplayInfo "Valid incoming Rapport ?" $rot 1 3000
                            }                        
                        }
                        set callentry $inputentry
                        set bool [CheckDouble]
                        if {$bool!= "TRUE"} {
                            CheckHeard $inputentry
                            GetBearDist
                        }
                    }
                } else {
                    DisplayCallsLocs
                }
            }
        }
    }
}
#######
CheckEntries
}

proc EvalLocator {} {
global widget locatorentry Entfernung callentry

if {$locatorentry!=""} {
    selection clear
    set locatorentry [string toupper $locatorentry]
    set len [string length $locatorentry]
    if {$len!=6} {
	set locatorentry {}
    } else {
	set res [regexp {^[A-R][A-R][0-9][0-9][A-X][A-X]$} $locatorentry]
	if {$res!=1} {
	    set locatorentry {}
            focus $widget(LocatorEntry)
        } else {
            focus $widget(InputEntry)
            GetBearDist
            CheckNewLocator $locatorentry
        }
    }   
} else {
    set locatorentry {}
    focus $widget(LocatorEntry)
}
}

proc EvalRSTin {} {
global widget rstinentry

if {$rstinentry!=""} {
    selection clear
    set res [regexp {^[1-5][1-9][A-Za-z0-9]+$} $rstinentry]
    if {$res!=1} {
        set rstinentry {}
    } else {
        focus $widget(InputEntry)
    }
} else {
    set rstinentry {}
    focus $widget(RSTinEntry)
}
}

proc EvalRSTout {} {
global widget rstoutentry

if {$rstoutentry!=""} {
    selection clear
    set res [regexp {^[1-5][1-9][A-Za-z0-9]+$} $rstoutentry]
    if {$res!=1} {
        set rstoutentry {}
        focus $widget(RSToutEntry)
    } else {
        focus $widget(InputEntry)
    }
} else {
    set rstoutentry {}
    focus $widget(RSToutEntry)
}
}

proc EvalUTC {} {
global UTCDatum widget utcentry manualUTC

set manualUTC TRUE
if {$utcentry!=""} {
    selection clear
    set utcentry [string toupper $utcentry]
    set utcentry [ValiDatum $utcentry]
    if {$utcentry!=""} {
        set utc [clock seconds]
        set UTCDatum [clock format $utc -format "%a,%d.%b.%Y" -gmt true]
        focus $widget(InputEntry)
    } else {
        focus $widget(UTCEntry)
    }
} else {
    set utcentry {}
    focus $widget(UTCEntry)
}
}

proc FillList {idx num} {
global saved ActBand totalentry Entfernung Richtung UTCDatum prefmode
global utcentry callentry rstoutentry rstinentry locatorentry
global NumberList UTCList UTCDatumList CallList RSToutList RSTinList
global LocatorList BandList ModeList PointsList BearingList

set NumberList [linsert $NumberList $idx $num]
set UTCList [linsert $UTCList $idx $utcentry]
set UTCDatumList [linsert $UTCDatumList $idx $UTCDatum]
set CallList [linsert $CallList $idx $callentry]
set RSToutList [linsert $RSToutList $idx $rstoutentry]
set RSTinList [linsert $RSTinList $idx $rstinentry]
set LocatorList [linsert $LocatorList $idx $locatorentry]
set BandList [linsert $BandList $idx $ActBand]
set ModeList [linsert $ModeList $idx $prefmode]
set PointsList [linsert $PointsList $idx $Entfernung]
set BearingList [linsert $BearingList $idx $Richtung]

set saved "FALSE"
}

proc FillListBoxes {idx num} {
global widget NumberList UTCList CallList RSToutList RSTinList
global LocatorList ModeList PointsList BearingList ActBand ActBandbac correctLine

if {$correctLine=="TRUE" && $ActBand!=$ActBandbac} {
} else {
    $widget(NumberList) insert $idx [lindex $NumberList $num]
    $widget(UTCList) insert $idx [lindex $UTCList $num]
    $widget(CallList) insert $idx [lindex $CallList $num]
    $widget(RSToutList) insert $idx [lindex $RSToutList $num]
    $widget(RSTinList) insert $idx [lindex $RSTinList $num]
    $widget(LocatorList) insert $idx [lindex $LocatorList $num]
    $widget(ModeList) insert $idx [lindex $ModeList $num]
    $widget(PointsList) insert $idx [lindex $PointsList $num]
    $widget(BearingList) insert $idx [lindex $BearingList $num]
}
}

proc GCOS {win} {
global PI

return [expr cos($win*$PI/180.0)]
}

proc GSIN {win} {
global PI

return [expr sin($win*$PI/180.0)]
}

proc GetBearDist {} {
global widget Entfernung Richtung locatorentry callentry
global prefmyloc OstL NordB MyOstL MyNordB

if {$locatorentry!="" && $locatorentry!="XXXXX"} {
    if {$locatorentry!=$prefmyloc} {
        QTHinWinkel $locatorentry "FALSE"
        Entf_Richt $MyOstL $MyNordB $OstL $NordB
    } else {
        set Entfernung 3
        set Richtung 0
    }
    SetBearing $Richtung $Entfernung
}
}

proc GetOPDat {} {
global OPDat OPKurve AnzOP color colidx Operator callLabel MaxQSOOP ScaleOP
global widget

set Datei {}
if {$OPDat!=""} {
    catch {set Datei [open $OPDat r]}
    if {$Datei==""} {
        Window show $widget(AlertWin)
    } else {
        while {[gets $Datei Zeile]>=0} {
            lappend OPs $Zeile
        }
        close $Datei

        set AnzOP 0
        set MaxQSOOP 0
        set colidx 0
        foreach Zeile $OPs {
            incr AnzOP
            set OP [lindex $Zeile 0]
            set Datum [lindex $Zeile 1]
            regsub -all {\.} $Datum " " Datum
            set Time [lindex $Zeile 2]
            set start [clock scan "$Datum $Time" -gmt true]

            set EndDatum [lindex $Zeile 3]
            regsub -all {\.} $EndDatum " " EndDatum

            set EndTime [lindex $Zeile 4]
            set ende [clock scan "$EndDatum $EndTime" -gmt true]

            set anz [lindex $Zeile 5]
            set farbe [lindex $Zeile 6]

            set OPKurve($AnzOP) "$OP $start $ende $anz $farbe"
            if {$anz>$MaxQSOOP} {
                set MaxQSOOP $anz
            }
            if {$farbe>$colidx} {
                set colidx $farbe
            }
        }
    }
set utc [CutTimeMinute [clock seconds]]
set OPKurve($AnzOP) "$OP $start $utc $anz $farbe"

set Operator $OP
set callLabel $Operator

if {$MaxQSOOP<10} {
    set ScaleOP 20.0
} else {
    set ScaleOP [expr (($MaxQSOOP / 10) + 1) * 10.0]
}
}
}

proc GetStat {} {
global AnzQSO PointsList CallList totalentry QSOKurve 
global StartHr ScaleQSO CanWidth CanHeight StartConTime AnzHrInt withdrawn 
global ScaleHR PtsKurve ScalePts ScaleKM KMKurve NumberList Pointslist

######### Calculate Statistics from loaded LogDat:

#### Calculate total Points and ODX
set Anzahl [llength $PointsList]
for {set i 0} {$i < $Anzahl} {incr i} {
    set points [lindex $PointsList $i]
    if {$points>0} {
        CheckODX $points [lindex $CallList $i] FALSE
        set totalentry [expr $totalentry + $points]
        incr AnzQSO
    }
}

#### Calculate StartTime from first Entry
set StartConTime [ReConstructTime 0]

#### Calculate EndTime from last Entry
set EndConTime [ReConstructTime end]

#### Anzahl hours seit Beginn des Contestes
CalHours

#### Read Operator-LogDat (DD_MM_YY.op)
GetOPDat

#### Calculate QSOKurve for statistical use only
set QSOKurve "$StartConTime 0"
set PtsKurve "$StartConTime 0"
set KMKurve "$StartConTime 0"

set j 0
set totalpts 0
set maxkmqso 0
for {set i $StartConTime} {$i <= $EndConTime} {incr i 60} {
    set Time [ReConstructTime $j]
    while {$Time>=$i && $Time<[expr $i+60]} {
        incr totalpts [lindex $PointsList $j]
        incr j
        set Time [ReConstructTime $j]
    }
    lappend QSOKurve $i $j
    lappend PtsKurve $i $totalpts
    set kmqso [expr $totalpts / $j]
    lappend KMKurve $i $kmqso
    if {$maxkmqso<$kmqso} {
        set maxkmqso $kmqso
    }   
}
set utc [CutTimeMinute [clock seconds]]
lappend QSOKurve $utc $j
lappend PtsKurve $utc $totalpts
lappend KMKurve $utc $kmqso

if {$AnzQSO<10} {
    set ScaleQSO 20.0
} else {
    set ScaleQSO [expr (($AnzQSO / 10) + 1) * 10.0]
}
if {$totalpts<1000} {
    set ScalePts 1000.0
} else {
    set ScalePts [expr (($totalpts / 1000) + 1) * 1000.0]
}
if {$maxkmqso<500} {
    set ScaleKM 500.0
} else {
    set ScaleKM [expr (($kmqso / 100) + 1) * 100.0]
}
ReScaleStatWin
UpdateStatWin FALSE
}

proc LoadHeard {} {
global HeardList HeardDat

set Datei {}
catch {set Datei [open $HeardDat r]}
if {$Datei != ""} {
    gets $Datei HeardList
    close $Datei
}
}

proc LoadPrefs {} {
global PrefDat prefmycall prefmyloc prefmode preflogpath
global widget modeLabel mylocLabel callLabel ActBand ticks
global prefSaveDelay prefAntExt2 ActBandbac prefBandChange 
global prefmodebac Operator prefDOK prefAntExt6 prefAntExt70
global prefAntExt23 prefAntExt13 prefAntExt8 prefAntExt5 prefAntExt3 
global prefAntExt125 prefAntExt63 prefAntExt35 prefAntExt25 prefAntExt2mm 
global prefAntExt12 AntExt

set Datei {}
catch {set Datei [open $PrefDat r]}
if {$Datei != ""} {
    gets $Datei prefmycall
    gets $Datei prefmyloc
    gets $Datei prefDOK
    gets $Datei preflogpath
    gets $Datei ActBand
    gets $Datei prefmode
    gets $Datei prefSaveDelay
    gets $Datei prefAntExt6
    gets $Datei prefAntExt2
    gets $Datei prefAntExt70
    gets $Datei prefAntExt23
    gets $Datei prefAntExt13
    gets $Datei prefAntExt8
    gets $Datei prefAntExt5
    gets $Datei prefAntExt3
    gets $Datei prefAntExt125
    gets $Datei prefAntExt63
    gets $Datei prefAntExt35
    gets $Datei prefAntExt25
    gets $Datei prefAntExt2mm
    gets $Datei prefAntExt12
    gets $Datei prefBandChange
    close $Datei

    set Operator $prefmycall
    set ActBandbac $ActBand
    set prefmodebac $prefmode
    set callLabel $prefmycall
    set mylocLabel $prefmyloc
    set modeLabel "Mode : $ActBand $prefmode"
    case $ActBand {
        "6m"      {set AntExt $prefAntExt6}
        "2m"      {set AntExt $prefAntExt2}
        "70cm"    {set AntExt $prefAntExt70}
        "23cm"    {set AntExt $prefAntExt23}
        "13cm"    {set AntExt $prefAntExt13}
        "8cm"     {set AntExt $prefAntExt8}
        "5cm"     {set AntExt $prefAntExt5}
        "3cm"     {set AntExt $prefAntExt3}
        "1.25cm"  {set AntExt $prefAntExt125}
        "6.3mm"   {set AntExt $prefAntExt63}
        "3.5mm"   {set AntExt $prefAntExt35}
        "2.5mm"   {set AntExt $prefAntExt25}
        "2mm"     {set AntExt $prefAntExt2mm}
        "1.2mm"   {set AntExt $prefAntExt12}
    }
    QTHinWinkel $prefmyloc "TRUE"
    if {$prefSaveDelay>0} { 
        set ticks [expr $prefSaveDelay * 60000]
        after $ticks SaveDelayed
    }
}
}

proc MarkInvalidListBoxes {el} {
global widget saved totalentry PointsList BearingList NumberList
global ODX ODXCall CallList AnzQSO Entfernung

if {$el!=""} {
    set idx [$widget(NumberList) get $el]
    incr idx -1
    set km [lindex $PointsList $idx]
    if {$km!=0} {
        set totalentry [expr $totalentry - $km]

        set PointsList [lreplace $PointsList $idx $idx 0]
        set BearingList [lreplace $BearingList $idx $idx "---"]

        incr AnzQSO -1
        ReplaceQSOOP $idx TRUE

        $widget(PointsList) delete $el
        $widget(BearingList) delete $el
        $widget(PointsList) insert $el 0
        $widget(BearingList) insert $el "---"
        set Entfernung 0
        set saved FALSE
        SaveLine $idx
        SaveOP

        if {$ODXCall==[lindex $CallList $idx]} {
            set ODX {}
            set ODXCall {}
            set Anzahl [llength $PointsList]
            for {set i 0} {$i<$Anzahl} {incr i} {
                set dumodx [lindex $PointsList $i]
                set dumcall [lindex $CallList $i]
                if {$dumodx>$ODX} {
                    set ODX $dumodx
                    set ODXCall $dumcall
                }
            }
        }
    }
}
}

proc NewLog {} {
global saved LogDat widget OPDat preflogpath

if {$saved!="TRUE"} {
    if {$LogDat==""} {
        set answer [tk_dialog .wantSaveWin Stop!! "Do you want to save first?" {} 0 YEP NOP]
        if {$answer==0} {
            SaveLog TRUE
        }
    } else {
        set answer [tk_dialog .wantSaveWin Stop!! "Do you want to save first?" {} 0 YEP NOP]
        if {$answer==0} {
            SaveLog FALSE
}   }   }

set utc [clock seconds]
set LogDat [clock format $utc -format "%d_%b_%Y.log" -gmt true]
set LogDat $preflogpath$LogDat

if {[file exists $OPDat]} {
    file rename -force $OPDat $OPDat.bak
}
set OPDat [clock format $utc -format "%d_%b_%Y.op" -gmt true]
set OPDat $preflogpath$OPDat
ResetAll
AddOP
SaveOP

focus $widget(InputEntry)
}

proc NewNumber {} {
global widget numberentry number numberLabel rot

DisplayInfo "No function, sorry!" $rot 1 3000
Window hide $widget(NumberWin)
}

proc NextEntries {} {
global number numberLabel manualUTC correctLine prefmodebac prefmode
global ActBandbac ActBand modeLabel listcopied NumberList LastHRQSONr

if {$correctLine=="TRUE"} {
    set prefmode $prefmodebac
    set ActBand $ActBandbac
    set modeLabel "Mode : $ActBand $prefmode"
    set correctLine FALSE
}
set manualUTC FALSE
set number [llength $NumberList]
incr number
set num [TranslateNumber $number]
set numberLabel "Number : $num"

DelEntries $num
ResetInfo
if {$listcopied=="TRUE"} {
    CopyList2ListBox
}
}

proc OpenLog {} {
global widget LogDat FileTypes preflogpath number numberLabel
global saved rstoutentry infoentry Append OPDat
global NumberList UTCList UTCDatumList CallList RSToutList RSTinList
global LocatorList BandList ModeList PointsList BearingList

if {$saved!="TRUE"} {
    if {$LogDat==""} {
        set answer [tk_dialog .wantSaveWin Stop!! "Do you want to save first?" {} 0 YEP NOP]
        if {$answer==0} {
            SaveLog TRUE
        }
    } else {
        set answer [tk_dialog .wantSaveWin Stop!! "Do you want to save first?" {} 0 YEP NOP]
        if {$answer==0} {
            SaveLog FALSE
}   }   }

set LogDat [tk_getOpenFile -defaultextension ".log" -filetypes $FileTypes -initialdir $preflogpath]
if {$LogDat!=""} {
    regsub -nocase {\.log$} $LogDat ".op" OPDat
    ResetAll

    catch {set Datei [open $LogDat r]}
    if {$Datei != ""} {
        set infoentry "Loading ..."
        $widget(InfoEntry) configure -bg #eebb00
        $widget(MainWindow) configure -cursor {watch black white}
        update idletasks

        while {[gets $Datei Zeile]>=0} {
            lappend QSOs $Zeile
        }
        close $Datei

        set line 0
        set linebac -1
        foreach Zeile $QSOs {
            set line [expr [lindex $Zeile 0]-1]

            if {$linebac!=[expr $line-1]} {
                DelOneList $line
            } else {
                set linebac $line
            }
            set NumberList [linsert $NumberList $line [lindex $Zeile 0]]
            set UTCDatumList [linsert $UTCDatumList $line [lindex $Zeile 1]]
            set UTCList [linsert $UTCList $line [lindex $Zeile 2]]
            set call [lindex $Zeile 3]
            set CallList [linsert $CallList $line $call]
            set BandList [linsert $BandList $line [lindex $Zeile 4]]
            set ModeList [linsert $ModeList $line [lindex $Zeile 5]]
            set RSToutList [linsert $RSToutList $line [lindex $Zeile 6]]
            set RSTinList [linsert $RSTinList $line [lindex $Zeile 7]]
            set LocatorList [linsert $LocatorList $line [lindex $Zeile 8]]
            set PointsList [linsert $PointsList $line [lindex $Zeile 9]]
            set BearingList [linsert $BearingList $line [lindex $Zeile 10]]

        }
        CopyList2ListBox
        GetStat
        NextEntries
        CalBestRateFromLog
        set Append TRUE
	ResetInfo
        $widget(MainWindow) configure -cursor {top_left_arrow black white}
    }   
}
}

proc QSOInvalid {} {
global utcentry callentry rstoutentry rstinentry locatorentry 
global Entfernung Richtung rot number widget correctLine boxidx

DisplayInfo "Saving as invalid QSO ..." $rot 0 3000

set idx [expr $number - 1]

if {$utcentry==""} {
    set utcentry "XX:XX"
}
if {$callentry==""} {
    set callentry "XXXXX"
}
if {$rstoutentry==""} {
    set rstoutentry "XXXXX"
}
if {$rstinentry==""} {
    set rstinentry "XXXXX"
}
if {$locatorentry==""} {
    set locatorentry "XXXXX"
}
set Entfernung 0
set Richtung "---"

if {$correctLine=="TRUE"} {
    ReplaceOneList $idx
    DelOneListBoxes $boxidx
    FillListBoxes $boxidx $idx
    SaveLine $idx
} else {
    set endidx [$widget(NumberList) size]
    FillList $idx $number
    FillListBoxes $endidx $idx
    SaveLine $idx
    ViewLastLineListBoxes
}

NextEntries
focus $widget(InputEntry)
}

proc QTHinWinkel {QTH my} {
global MyOstL MyNordB OstL NordB

    for {set i 0} {$i < 6} {incr i} {
	set dum [string index $QTH $i]
	if {![regexp {[0-9]} $dum]} {
	    scan $dum "%c" dum
	    incr dum -65
	}
	set loc($i) $dum
    }
    set Ost [expr -180+$loc(0)*20+$loc(2)*2+$loc(4)/12.0+0.0416666667]
    set Nord [expr -90+$loc(1)*10+$loc(3)+$loc(5)/24.0+0.0208333333]

    if {$my=="TRUE"} {
	set MyOstL $Ost
	set MyNordB $Nord
    } else {
	set OstL $Ost
	set NordB $Nord
    }
}

proc Quit {} {
global widget LogDat saved

if {$saved!="TRUE"} {
    if {$LogDat==""} {
        set answer [tk_dialog .wantSaveWin Stop!! "Do you want to save first?" {} 0 YEP NOP]
        if {$answer==0} {
            SaveLog TRUE
        }
    } else {
        set answer [tk_dialog .wantSaveWin Stop!! "Do you want to save first?" {} 0 YEP NOP]
        if {$answer==0} {
            SaveLog FALSE
}   }   }

SaveHeard

destroy .; exit
}

proc ReConstructTime {idx} {
global UTCList UTCDatumList

set Time [lindex $UTCList $idx]
set Datum [lindex $UTCDatumList $idx]
regsub -all {\.} $Datum " " Datum

return [clock scan "$Datum $Time" -gmt true]
}

proc ReScaleStatWin {} {
global widget CanWidth CanHeight ScaleQSO RoseFont AnzHrInt ScaleHR withdrawn
global StartConTime XOffset ScalePts ScaleKM ScaleOP OPKurve color

set utc [clock seconds]
set std [clock format $utc -format "%H" -gmt true]
set std [string trimleft $std "0"]

set starthr [clock format $StartConTime -format "%H" -gmt true]
if {$starthr=="00"} {
    set starthr 0
} else {
    set starthr [string trimleft $starthr "0"]
}

set TimeOffset [clock format $StartConTime -format "%d %b %Y %H00" -gmt true]
set TimeOffset [clock scan $TimeOffset -gmt TRUE]
set TimeOffset [expr $StartConTime - $TimeOffset]

set ScaleHR [expr ($AnzHrInt + 1) * 3600.0]
set XOffset [expr round(($CanWidth / $ScaleHR) * $TimeOffset)]

if {[winfo exists $widget(StatWin)]==1} {
    $widget(StatQSO) delete graph
    $widget(StatPts) delete graph
    $widget(StatKM) delete graph
    $widget(StatOP) delete graph
    set OPLabels [winfo children $widget(StatOPFrame)]
    foreach i $OPLabels {
        destroy $i
    }

##################### Draw QSO/hr and the X-Axes of the other Graphs too ########################
    #### Draw Axes

    $widget(StatQSO) create line 10 [expr $CanHeight+5] [expr $CanWidth+18] [expr $CanHeight+5] -arrow last -tags graph
    $widget(StatQSO) create line 10 [expr $CanHeight+5] 10 2 -arrow last -tags graph
    $widget(StatQSO) create text 30 10 -text {[QSO]} -font $RoseFont -anchor w -tags graph
    $widget(StatQSO) create text $CanWidth [expr $CanHeight-2] -text {[h]} -font $RoseFont -anchor w -tags graph

    if {$ScaleQSO>100} {
        set inc 50
    } else {
        set inc 10
    }
    #### Draw Y-Axis
    for {set i $inc} {$i <= $ScaleQSO} {incr i $inc} {
        set Y [TransCoordY $i $ScaleQSO]
        $widget(StatQSO) create line 8 $Y 10 $Y -tags graph
        $widget(StatQSO) create text 15 [expr $Y+2] -text $i -anchor w -font $RoseFont -tags graph
    }
    #### Draw X-Axis
    set anz [expr $AnzHrInt+1]
    if {$anz>=20} {
        set inc 5
    } else {
        set inc 1
    }
    set zwo 1
    for {set i 0} {$i <= $anz} {incr i $inc} {
        set X [expr round(($CanWidth / ($AnzHrInt+1.0)) * $i) + 10]
        $widget(StatQSO) create line $X [expr $CanHeight+9] $X [expr $CanHeight+5] -tags graph
        $widget(StatPts) create line $X [expr $CanHeight+9] $X [expr $CanHeight+5] -tags graph
        $widget(StatKM) create line $X [expr $CanHeight+9] $X [expr $CanHeight+5] -tags graph
        $widget(StatOP) create line $X [expr $CanHeight+9] $X [expr $CanHeight+5] -tags graph
        if {$anz>10 && $inc==1} {
            if {$zwo==1} {
                $widget(StatQSO) create text $X [expr $CanHeight+14] -text $starthr -font $RoseFont -tags graph
                $widget(StatPts) create text $X [expr $CanHeight+14] -text $starthr -font $RoseFont -tags graph
                $widget(StatKM) create text $X [expr $CanHeight+14] -text $starthr -font $RoseFont -tags graph
                $widget(StatOP) create text $X [expr $CanHeight+14] -text $starthr -font $RoseFont -tags graph
            }
            set zwo [expr 1 - $zwo]
        } else {
            $widget(StatQSO) create text $X [expr $CanHeight+14] -text $starthr -font $RoseFont -tags graph
            $widget(StatPts) create text $X [expr $CanHeight+14] -text $starthr -font $RoseFont -tags graph
            $widget(StatKM) create text $X [expr $CanHeight+14] -text $starthr -font $RoseFont -tags graph
            $widget(StatOP) create text $X [expr $CanHeight+14] -text $starthr -font $RoseFont -tags graph
        }
        incr starthr $inc
        if {$starthr>=24} {
            set starthr [expr $starthr - 24]
        }
    }
###############################################################
###################### Draw Points/hr #########################
    #### Draw Axes

    $widget(StatPts) create line 10 [expr $CanHeight+5] [expr $CanWidth+18] [expr $CanHeight+5] -arrow last -tags graph
    $widget(StatPts) create line 10 [expr $CanHeight+5] 10 2 -arrow last -tags graph
    $widget(StatPts) create text 70 10 -text {[Points]} -font $RoseFont -tags graph
    $widget(StatPts) create text $CanWidth [expr $CanHeight-2] -text {[h]} -font $RoseFont -anchor w -tags graph

    if {$ScalePts>10000} {
        set inc 5000
    } elseif {$ScalePts>3000} {
        set inc 1000
    } elseif {$ScalePts>1000} {
        set inc 500
    } else {
        set inc 200
    }
    #### Draw Y-Axis
    for {set i $inc} {$i <= $ScalePts} {incr i $inc} {
        set Y [TransCoordY $i $ScalePts]
        $widget(StatPts) create line 8 $Y 10 $Y -tags graph
        $widget(StatPts) create text 15 [expr $Y+2] -text $i -anchor w -font $RoseFont -tags graph
    }

################################################################
###################### Draw (KM/QSO)/hr ######################
    #### Draw Axes

    $widget(StatKM) create line 10 [expr $CanHeight+5] [expr $CanWidth+18] [expr $CanHeight+5] -arrow last -tags graph
    $widget(StatKM) create line 10 [expr $CanHeight+5] 10 2 -arrow last -tags graph
    $widget(StatKM) create text 70 10 -text {[km/QSO]} -font $RoseFont -tags graph
    $widget(StatKM) create text $CanWidth [expr $CanHeight-2] -text {[h]} -font $RoseFont -anchor w -tags graph

    if {$ScaleKM>500} {
        set inc 200
    } else {
        set inc 100
    }
    #### Draw Y-Axis
    for {set i $inc} {$i <= $ScaleKM} {incr i $inc} {
        set Y [TransCoordY $i $ScaleKM]
        $widget(StatKM) create line 8 $Y 10 $Y -tags graph
        $widget(StatKM) create text 15 [expr $Y+2] -text $i -anchor w -font $RoseFont -tags graph
    }

################################################################
###################### Draw Operator-Statistic ######################
    #### Draw Axes

    $widget(StatOP) create line 10 [expr $CanHeight+5] [expr $CanWidth+18] [expr $CanHeight+5] -arrow last -tags graph
    $widget(StatOP) create line 10 [expr $CanHeight+5] 10 2 -arrow last -tags graph
    $widget(StatOP) create text 30 10 -text {[QSOs/Operator]} -font $RoseFont -anchor w -tags graph
    $widget(StatOP) create text $CanWidth [expr $CanHeight-2] -text {[h]} -font $RoseFont -anchor w -tags graph

    if {$ScaleOP>100} {
        set inc 50
    } else {
        set inc 10
    }
    #### Draw Y-Axis
    for {set i $inc} {$i <= $ScaleOP} {incr i $inc} {
        set Y [TransCoordY $i $ScaleOP]
        $widget(StatOP) create line 8 $Y 10 $Y -tags graph
        $widget(StatOP) create text 15 [expr $Y+2] -text $i -anchor w -font $RoseFont -tags graph
    }
    #### Draw LabelButtons
    set anz [array size OPKurve]
    for {set i 1} {$i<=$anz} {incr i} {
        set col [lindex $OPKurve($i) 4]
        set OPLabel [lindex $OPKurve($i) 0]
        set OPLabel "$OPLabel:[lindex $OPKurve($i) 3]"
        label $widget(StatOPFrame).lab$i -text $OPLabel -bg $color($col) -borderwidth 1 -relief sunken -font $RoseFont
        pack $widget(StatOPFrame).lab$i -side left
    }
}
}

proc ReplaceOneList {idx} {
global UTCDatumList UTCList NumberList CallList 
global BandList BearingList RSToutList RSTinList 
global LocatorList ModeList PointsList saved 
global saved ActBand totalentry Entfernung Richtung UTCDatum prefmode
global utcentry callentry rstoutentry rstinentry locatorentry

if {$idx!=""} {
    set UTCList [lreplace $UTCList $idx $idx $utcentry]
    set UTCDatumList [lreplace $UTCDatumList $idx $idx $UTCDatum]
    set CallList [lreplace $CallList $idx $idx $callentry]
    set RSToutList [lreplace $RSToutList $idx $idx $rstoutentry]
    set RSTinList [lreplace $RSTinList $idx $idx $rstinentry]
    set LocatorList [lreplace $LocatorList $idx $idx $locatorentry]
    set BandList [lreplace $BandList $idx $idx $ActBand]
    set ModeList [lreplace $ModeList $idx $idx $prefmode]
    set PointsList [lreplace $PointsList $idx $idx $Entfernung]
    set BearingList [lreplace $BearingList $idx $idx $Richtung]

    set saved "FALSE"
}
}

proc ReplaceQSOOP {idx del} {
global OPKurve UTCList UTCDatumList

set time [ReConstructTime $idx]

set anz [array size OPKurve]
for {set i 1} {$i<=$anz} {incr i} {
    set start [lindex $OPKurve($i) 1]
    set end [lindex $OPKurve($i) 2]

    if {$time>=$start && $time<=$end} {
        set count [lindex $OPKurve($i) 3]
        if {$del=="TRUE"} {
            incr count -1
        } else {
            incr count
        }
        set OPKurve($i) [lreplace $OPKurve($i) 3 3 $count]
        break
    }
}
}

proc ResetAll {} {
global number numberLabel saved totalentry Append AnzQSO AnzOP
global utcentry UTCDatum manualUTC QSOKurve AnzHr AnzHrBak ScaleQSO
global PtsKurve ScalePts BandChange ScaleKM KMKurve OPKurve colidx

set number 1
set numberLabel "Number : 001"
set utc [clock seconds]
if {$utcentry == ""} {
    set utcentry [clock format $utc -format "%H:%M" -gmt true]
    set UTCDatum [clock format $utc -format "%a,%d.%b.%Y" -gmt true]
}
DelEntries "001"
DelStatEntries

DelAllListBoxes
DelAllLists

set saved TRUE
set correctLine FALSE
set Append HMM
set manualUTC FALSE
set BandChange 0

set AnzQSO 0
set AnzHr 1.0
set AnzHrBak 1.0
set ScaleQSO 20.0
set ScalePts 1000.0
set ScaleKM 500.0
set QSOKurve "$utc 0 $utc 0"
set PtsKurve "$utc 0 $utc 0"
set KMKurve "$utc 0 $utc 0"

if {[info exists OPKurve]} {
    unset OPKurve
}
set AnzOP 0
set colidx 0

ReScaleStatWin
UpdateStatWin FALSE
}

proc ResetInfo {} {
global widget infoentry

set infoentry {}
$widget(InfoEntry) configure -bg #d9d9d9
}

proc SaveDelayed {} {
global ticks saved

if {$saved=="FALSE"} {
    SaveLog FALSE
}
after $ticks SaveDelayed
}

proc SaveHeard {} {
global HeardList HeardDat

set Datei {}
if {$HeardList!=""} {
    catch {set Datei [open $HeardDat w]}
    if {$Datei != ""} {
        puts $Datei $HeardList
        close $Datei
    }
}
}

proc SaveLine {idx} {
global widget LogDat FileTypes preflogpath
global infoentry Append wait orange ActBand orange
global NumberList UTCList UTCDatumList CallList RSToutList RSTinList
global LocatorList BandList ModeList PointsList BearingList

if {$wait=="FALSE"} {
    if {$Append=="HMM"} {
        set res [file exists $LogDat]
        if {$res == "1"} {
            set answer [tk_dialog .fileExists Stop!! "This LogFile exists!\n Overwrite it?" {} 0 YEP NOP]
            case $answer {
                0 {catch {set Datei [open $LogDat w]}
                   close $Datei
                   set Append TRUE}
                1 {set Append FALSE}
            }
        } else {
            set Append TRUE
        }
    }
    
    if {$LogDat=="" || $Append=="FALSE"} {
        set err [catch {set LogDat [tk_getSaveFile -defaultextension ".log" -filetypes $FileTypes -initialdir $preflogpath]}]
        if {$err!=0} {
            Window show $widget(AlertWin)
            set saved "FALSE"
        }
        if {$LogDat==""} {
            set Append HMM
        } else {
            set Append TRUE
        }
    }

    if {$LogDat!="" && $Append=="TRUE"} {
        set Datei {}
        catch {set Datei [open $LogDat a+]}
        if {$Datei == ""} {
            Window show $widget(AlertWin)
        } else {
            DisplayInfo "Saving ..." $orange 0 3000
            $widget(MainWindow) configure -cursor {watch black white}
            update idletasks
                puts -nonewline $Datei [lindex $NumberList $idx]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $UTCDatumList $idx]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $UTCList $idx]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $CallList $idx]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $BandList $idx]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $ModeList $idx]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $RSToutList $idx]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $RSTinList $idx]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $LocatorList $idx]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $PointsList $idx]
                puts -nonewline $Datei " "
                puts $Datei [lindex $BearingList $idx]
            flush $Datei
            close $Datei
            ResetInfo
            $widget(MainWindow) configure -cursor {top_left_arrow black white}
        }
    }
} else {
    DisplayInfo "Press Return to continue ..." $orange 1 3000
}
}

proc SaveLog {as} {
global widget LogDat FileTypes preflogpath OPDat
global saved totalentry infoentry Append wait orange
global NumberList UTCList UTCDatumList CallList RSToutList RSTinList
global LocatorList BandList ModeList PointsList BearingList

if {$wait=="FALSE"} {
    if {$Append=="HMM"} {
        set res [file exists $LogDat]
        if {$res == "1"} {
            set answer [tk_dialog .fileExists Stop!! "This LogFile exists!\n Overwrite it?" {} 0 YEP NOP]
            case $answer {
                0  {set as FALSE}
                1  {set as TRUE}
            }
        } else {
            set Append TRUE
        }
    }

    if {$LogDat=="" || $as=="TRUE"} {
        set err [catch {set LogDat [tk_getSaveFile -defaultextension ".log" -filetypes $FileTypes -initialdir $preflogpath]}]
        if {$err!=0} {
            Window show $widget(AlertWin)
            set saved "FALSE"
        }
        if {$LogDat==""} {
            set Append HMM
        } else {
            set Append TRUE
        }
    }

    if {$LogDat!="" && $Append=="TRUE"} {
        set Datei {}
        catch {set Datei [open $LogDat w]}
        if {$Datei == ""} {
            Window show $widget(LogFileWin)
            set saved "FALSE"
        } else {
            DisplayInfo "Saving ..." $orange 0 3000
            $widget(MainWindow) configure -cursor {watch black white}
            update idletasks

            set Anzahl [llength $NumberList]
            for {set i 0} {$i < $Anzahl} {incr i} {
                puts -nonewline $Datei [lindex $NumberList $i]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $UTCDatumList $i]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $UTCList $i]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $CallList $i]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $BandList $i]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $ModeList $i]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $RSToutList $i]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $RSTinList $i]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $LocatorList $i]
                puts -nonewline $Datei " "
                puts -nonewline $Datei [lindex $PointsList $i]
                puts -nonewline $Datei " "
                puts $Datei [lindex $BearingList $i]
            }
            flush $Datei
            close $Datei
            set saved TRUE
            regsub -nocase {\.log$} $LogDat ".op" OPDat
            SaveOP

            ResetInfo
            $widget(MainWindow) configure -cursor {top_left_arrow black white}
        }
    } else {
        set saved "FALSE"
    }
} else {
    DisplayInfo "Press Return to continue ..." $orange 1 3000
}
}

proc SaveOP {} {
global OPDat OPKurve

set Datei {}
if {$OPDat!=""} {
    catch {set Datei [open $OPDat w]}
    if {$Datei==""} {
        Window show $widget(AlertWin)
    } else {
        set anz [array size OPKurve]
        for {set i 1} {$i<=$anz} {incr i} {
            set op [lindex $OPKurve($i) 0]
            set start [lindex $OPKurve($i) 1]
            set start [clock format $start -format "%d.%b.%Y %H:%M" -gmt true]
            set end [lindex $OPKurve($i) 2]
            set end [clock format $end -format "%d.%b.%Y %H:%M" -gmt true]
            set count [lindex $OPKurve($i) 3]
            set farbe [lindex $OPKurve($i) 4]
            puts $Datei "$op $start $end $count $farbe"
        }
        close $Datei
    }
}
}

proc SavePrefs {} {
global prefmycall prefmyloc prefmode callLabel mylocLabel modeLabel
global preflogpath widget PrefDat ActBand prefSaveDelay prefAntExt2
global prefBandChange number prefDOK prefAntExt6 prefAntExt70 
global prefAntExt23 prefAntExt13 prefAntExt8 prefAntExt5 prefAntExt3 
global prefAntExt125 prefAntExt63 prefAntExt35 prefAntExt25 prefAntExt2mm 
global prefAntExt12 AntExt

set Datei {}
set mem $prefSaveDelay
if {$preflogpath=="" || $prefmycall=="" || $prefmyloc=="" || $prefmode=="" || $prefSaveDelay==""} {
    Window show $widget(AlertWin)
} else {
    catch {set Datei [open $PrefDat w]}
    if {$Datei == ""} {
        Window show $widget(AlertWin)
    } else {
        puts $Datei $prefmycall
        puts $Datei $prefmyloc
        puts $Datei $prefDOK
        puts $Datei $preflogpath
        puts $Datei $ActBand
        puts $Datei $prefmode
        puts $Datei $prefSaveDelay
        puts $Datei $prefAntExt6
        puts $Datei $prefAntExt2
        puts $Datei $prefAntExt70
        puts $Datei $prefAntExt23
        puts $Datei $prefAntExt13
        puts $Datei $prefAntExt8
        puts $Datei $prefAntExt5
        puts $Datei $prefAntExt3
        puts $Datei $prefAntExt125
        puts $Datei $prefAntExt63
        puts $Datei $prefAntExt35
        puts $Datei $prefAntExt25
        puts $Datei $prefAntExt2mm
        puts $Datei $prefAntExt12
        puts $Datei $prefBandChange
        close $Datei
        Window hide $widget(PrefWin)
        set callLabel $prefmycall
        set mylocLabel $prefmyloc
        set modeLabel "Mode : $ActBand $prefmode"
        set ticks [expr $prefSaveDelay * 60000]
        case $ActBand {
            "6m"      {set AntExt $prefAntExt6}
            "2m"      {set AntExt $prefAntExt2}
            "70cm"    {set AntExt $prefAntExt70}
            "23cm"    {set AntExt $prefAntExt23}
            "13cm"    {set AntExt $prefAntExt13}
            "8cm"     {set AntExt $prefAntExt8}
            "5cm"     {set AntExt $prefAntExt5}
            "3cm"     {set AntExt $prefAntExt3}
            "1.25cm"  {set AntExt $prefAntExt125}
            "6.3mm"   {set AntExt $prefAntExt63}
            "3.5mm"   {set AntExt $prefAntExt35}
            "2.5mm"   {set AntExt $prefAntExt25}
            "2mm"     {set AntExt $prefAntExt2mm}
            "1.2mm"   {set AntExt $prefAntExt12}
        }
        QTHinWinkel $prefmyloc "TRUE"
        if {$prefSaveDelay>0 && $mem==0} { 
            after $ticks SaveDelayed
        }
    }
    CheckMode [TranslateNumber $number]
}
}

proc ScrollAll {idx idx2} {
global widget

    $widget(UTCList) yview moveto $idx
    $widget(CallList) yview moveto $idx
    $widget(RSToutList) yview moveto $idx
    $widget(RSTinList) yview moveto $idx
    $widget(LocatorList) yview moveto $idx
    $widget(ModeList) yview moveto $idx
    $widget(PointsList) yview moveto $idx
    $widget(BearingList) yview moveto $idx

.top19.fra37.fra42.02.scr43 set $idx $idx2
}

proc ScrollListBoxes {idx idx2 {idx3 0}} {
global widget

if {$idx3 == 0} {
    $widget(NumberList) yview $idx $idx2
    $widget(UTCList) yview $idx $idx2
    $widget(CallList) yview $idx $idx2
    $widget(RSToutList) yview $idx $idx2
    $widget(RSTinList) yview $idx $idx2
    $widget(LocatorList) yview $idx $idx2
    $widget(ModeList) yview $idx $idx2
    $widget(PointsList) yview $idx $idx2
    $widget(BearingList) yview $idx $idx2
} else {
    $widget(NumberList) yview $idx $idx2 $idx3
    $widget(UTCList) yview $idx $idx2 $idx3
    $widget(CallList) yview $idx $idx2 $idx3
    $widget(RSToutList) yview $idx $idx2 $idx3
    $widget(RSTinList) yview $idx $idx2 $idx3
    $widget(LocatorList) yview $idx $idx2 $idx3
    $widget(ModeList) yview $idx $idx2 $idx3
    $widget(PointsList) yview $idx $idx2 $idx3
    $widget(BearingList) yview $idx $idx2 $idx3
}
}

proc SetBearing {bear range} {
global bearingLabel widget orange AntExt drawn

if {$bear>=0 && $bear<=360} {
    if {$drawn=="TRUE"} {
        DelBearCanv
    }
    set bearingLabel "km : $range    Brg : $bear"
    set ext [expr $AntExt / 2]
    set angle [expr 90 - $bear - $ext]
    set mitte [expr 90 - $bear]
    $widget(BearCanv) create arc 15 10 135 57 -start $angle -extent $AntExt -fill $orange -tags Direct
    $widget(BearCanv) create arc 15 10 135 57 -start $mitte -extent 0 -fill #000 -tags Direct
    update
    set drawn TRUE
} else {
    DelBearCanv
}
}

proc SetUTC {} {
global utcentry UTCDatum manualUTC timeLabel

set utc [clock seconds]
set timeLabel [clock format $utc -format "%H:%M UTC -- %a, %d.%b.%Y" -gmt true]

if {$manualUTC=="FALSE"} {
    set utcentry [clock format $utc -format "%H:%M" -gmt true]
    set UTCDatum [clock format $utc -format "%a,%d.%b.%Y" -gmt true]
}
after 5000 SetUTC
}

proc TransCoordX {sec} {
global CanWidth ScaleHR StartConTime XOffset

set sec [expr $sec - $StartConTime]
return [expr round((($CanWidth / $ScaleHR) * $sec) + 10.0 + $XOffset)]
}

proc TransCoordY {Pt Unit} {
global CanHeight

return [expr round($CanHeight - (($CanHeight / $Unit) * $Pt) + 5.0)]
}

proc TranslateNumber {number} {
if {$number>=10 && $number<100} {
    return "0$number"
} elseif {$number<10} {
    return "00$number"
} elseif {$number>=100} {
    return $number
}
}

proc UpdateStatWin {process} {
global widget CanWidth CanHeight ScaleQSO ScaleHR AnzHrInt AnzQSO Operator StartConTime
global QSOKurve PointsKurve KMKurve OPKurve AnzHrBakInt ticks withdrawn Operator rot
global totalentry ScalePts PtsKurve KMKurve ScaleKM kmQSOentry OPKurve AnzOP color
global ScaleOP MaxQSOOP

set ScaleHR [expr ($AnzHrInt + 1) * 3600.0]

if {$process=="TRUE"} {
    set utc [CutTimeMinute [clock seconds]]
    lappend QSOKurve $utc $AnzQSO
    lappend PtsKurve $utc $totalentry
    lappend KMKurve $utc $kmQSOentry
    set OPKurve($AnzOP) [lreplace $OPKurve($AnzOP) 2 2 $utc]
}

if {[winfo exists $widget(StatWin)]==1} {
    if {$process=="TRUE"} {
        if {$AnzHrInt>$AnzHrBakInt} {
            set AnzHrBakInt $AnzHrInt
            set withdrawn TRUE
            ReScaleStatWin
        }
        if {$AnzQSO>$ScaleQSO} {
            set ScaleQSO [expr (($AnzQSO / 10) + 1) * 10.0]
            set withdrawn TRUE
            ReScaleStatWin
        }
        if {$MaxQSOOP>$ScaleOP} {
            set ScaleOP [expr (($MaxQSOOP / 10) + 1) * 10.0]
            set withdrawn TRUE
            ReScaleStatWin
        }
        if {$totalentry>$ScalePts} {
            set ScalePts [expr (($totalentry / 1000) + 1) * 1000.0]
            set withdrawn TRUE
            ReScaleStatWin
        }
        if {$kmQSOentry>$ScaleKM} {
            set ScaleKM [expr (($kmQSOentry / 100) + 1) * 100.0]
            set withdrawn TRUE
            ReScaleStatWin
        }
    }
    $widget(StatQSO) delete kurven
    $widget(StatPts) delete kurven
    $widget(StatKM) delete kurven
    $widget(StatOP) delete kurven
   
    #### Draw StatQSO
    set linie {}
    set len [llength $QSOKurve]
    for {set i 0} {$i<$len} {incr i 2} {
        set X [TransCoordX [lindex $QSOKurve $i]]
        set Y [TransCoordY [lindex $QSOKurve [expr $i+1]] $ScaleQSO]
        lappend linie $X $Y
    }
    eval $widget(StatQSO) create line $linie -fill $rot -smooth TRUE -tags kurven 

    #### Draw StatPts
    set linie {}
    set len [llength $PtsKurve]
    for {set i 0} {$i<$len} {incr i 2} {
        set X [TransCoordX [lindex $PtsKurve $i]]
        set Y [TransCoordY [lindex $PtsKurve [expr $i+1]] $ScalePts]
        lappend linie $X $Y
    }
    eval $widget(StatPts) create line $linie -fill $rot -smooth TRUE -tags kurven 

    #### Draw StatKM
    set linie {}
    set len [llength $KMKurve]
    for {set i 0} {$i<$len} {incr i 2} {
        set X [TransCoordX [lindex $KMKurve $i]]
        set Y [TransCoordY [lindex $KMKurve [expr $i+1]] $ScaleKM]
        lappend linie $X $Y
    }
    eval $widget(StatKM) create line $linie -fill $rot -smooth TRUE -tags kurven 

    #### Draw StatOP
    set Y2 [expr $CanHeight+5]

    set count [array size OPKurve]
    for {set i 1} {$i<=$count} {incr i} {
        eval set X1 [TransCoordX [lindex $OPKurve($i) 1]]
        eval set X2 [TransCoordX [lindex $OPKurve($i) 2]]
        set anz [lindex $OPKurve($i) 3]
        set col [lindex $OPKurve($i) 4]
        if {$anz>0} {
            eval set Y1 [TransCoordY $anz $ScaleOP]
            $widget(StatOP) create rectangle $X1 $Y1 $X2 $Y2 -fill $color($col) -tags kurven
            $widget(StatOP) lower kurven
        } else {
            eval set null [$widget(StatOP) create line $X1 $Y2 $X2 $Y2 -fill $color($col) -tags kurven]
        }
        set OPLabel [lindex $OPKurve($i) 0]
        set OPLabel "$OPLabel:[lindex $OPKurve($i) 3]"
        $widget(StatOPFrame).lab$i configure -text $OPLabel
    }
}
if {$process=="TRUE"} {
    after 60000 {UpdateStatWin TRUE}
}
}

proc ValiDatum {text} {
set null "0"

set idx [string first ":" $text]
regsub ":" $text "" text
set len [string length $text]

switch $len {
	4 {set res [regexp {^[01]?[0-9]|2[0-3][0-5][0-9]$} $text]
	    if {$res!=1} {
		return {}
	    } else {
                if {$idx==-1} {set idx 2}
		set std [string range $text 0 [expr "$idx-1"]]
		set min [string range $text $idx end]
		if {$std<0 || $std>24 || $min<0 || $min>59} {
		    return {}
		} else {
		    return "$std:$min"
		}
	    }
	}
	3 {set res [regexp {^[0-9][0-5][0-9]$} $text]
	    if {$res!=1} {
		return {}
	    } else {
                if {$idx==-1} {set idx 1}
		set std [string range $text 0 [expr "$idx-1"]]
		set min [string range $text $idx end]
		if {$std<0 || $std>24 || $min<0 || $min>59} {
		    return {}
		} else {
                    if {$idx==1} {
		        return "0$std:$min"
                    } else {
                        return "$std:$min$null"
                    }
		}
	    }
	}
	2 {set res [regexp {^[0-9][0-9]$} $text]
	    if {$res!=1} {
		return {}
	    } else {
                if {$idx==-1} {set idx 2}
                switch $idx {
                    0  {
                        set std 0
                        set min [string range $text 0 end]
                        if {$min<=59} {
                            return "00:$min"
                        } else {
                            return {}
                        }
                    }
                    1  {
                        set std [string range $text 0 0]
                        set min [string range $text 1 end]
                        if {$std<=9 && $min<=5} {
                            return "0$std:$min$null"
                        } else {
                            return {}
                        }
                    }
                    2  {
                        set min 0
                        set std [string range $text 0 end]
                        if {$std<=23} {
                            return "$std:00"
                        } else {
                            return {}
                        }
                    }
                    default  {
                        return {}
                    }
                }
	    }
	}
	1 {set res [regexp {^[0-9]$} $text]
	    if {$res!=1} {
                return {}
            } else {
                if {$idx==-1} {set idx 1}
                switch $idx {
                   0   {
                        if {$text<=5} {
                            return "00:$text$null"
                        } else {
                            return {}
                        }
                   }
                   1   {
                        if {$text<=9} {
		            return "0$text:00"
                        } else {
                            return {}
                        }
                   }
		}
                default  {
                        return {}
                }
	    }
	}
	default {return {}}
    }
}

proc ViewLastLineListBoxes {} {
global widget

$widget(NumberList) yview moveto 1
$widget(UTCList) yview moveto 1
$widget(CallList) yview moveto 1
$widget(RSToutList) yview moveto 1
$widget(RSTinList) yview moveto 1
$widget(LocatorList) yview moveto 1
$widget(ModeList) yview moveto 1
$widget(PointsList) yview moveto 1
$widget(BearingList) yview moveto 1
}

proc WaitReturn {} {
global widget inputentry wait

bind $widget(InputEntry) <Return> {set ReturnPress 1}
bind $widget(MainWindow) <Key-F2> {}
bind $widget(MainWindow) <Key-F1> {}
set wait TRUE

vwait ReturnPress
bind $widget(InputEntry) <Return> {EvalInput}
bind $widget(MainWindow) <Key-F1> {EditLineWithKey}
bind $widget(MainWindow) <Key-F2> {
    set manualUTC TRUE
    focus $widget(UTCEntry)
    $widget(UTCEntry) selection range 0 end
}
set ReturnPress 0
set wait FALSE
}

proc main {argc argv} {
global widget saved LogDat OPDat preflogpath prefmyloc HeardDat
global StartConTime QSOKurve PtsKurve KMKurve

CreateColors
set saved "TRUE"
set utc [CutTimeMinute [clock seconds]]
set StartConTime $utc

set LogDat [clock format $utc -format "%d_%b_%Y.log" -gmt true]
set LogDat $preflogpath$LogDat

LoadPrefs

set OPDat [clock format $utc -format "%d_%b_%Y.op" -gmt true]
set OPDat $preflogpath$OPDat

set HeardDat $preflogpath$HeardDat
LoadHeard
SetUTC
AddOP
DisplayRose
CalTimer
focus $widget(InputEntry)
set QSOKurve "$utc 0"
set PtsKurve "$utc 0"
set KMKurve "$utc 0"
UpdateStatWin TRUE
}

proc Window {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 1x1+0+0
    wm maxsize $base 800 400
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm withdraw $base
    wm title $base "vt.tcl"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top17 {base} {
    if {$base == ""} {
        set base .top17
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 450x306+211+118
    wm maxsize $base 1600 1200
    wm minsize $base 300 215
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "Statistic"
    frame $base.fra18  -height 75 -relief groove -width 125 
    canvas $base.fra18.can19  -borderwidth 2 -height 0 -relief ridge -width 0 
    canvas $base.fra18.can20  -borderwidth 2 -height 0 -relief ridge -width 0 
    frame $base.fra23  -height 75 -relief groove -width 125 
    canvas $base.fra23.can25  -borderwidth 2 -height 0 -relief ridge -width 0 
    canvas $base.fra23.can26  -borderwidth 2 -height 0 -relief ridge -width 0 
    frame $base.fra24  -borderwidth 1 -height 21 -relief sunken 
    frame $base.fra27  -borderwidth 2 -height 75 -width 125 
    button $base.fra27.but28  -command {Window hide $widget(StatWin)
set withdrawn TRUE} -padx 9  -pady 3 -relief groove -text Close 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra18  -in .top17 -anchor center -expand 1 -fill both -side top 
    pack $base.fra18.can19  -in .top17.fra18 -anchor center -expand 1 -fill both -side left 
    pack $base.fra18.can20  -in .top17.fra18 -anchor center -expand 1 -fill both -side left 
    pack $base.fra23  -in .top17 -anchor center -expand 1 -fill both -side top 
    pack $base.fra23.can25  -in .top17.fra23 -anchor center -expand 1 -fill both -side left 
    pack $base.fra23.can26  -in .top17.fra23 -anchor center -expand 1 -fill both -side left 
    pack $base.fra24  -in .top17 -anchor center -expand 0 -fill x -pady 3 -side top 
    pack $base.fra27  -in .top17 -anchor center -expand 0 -fill x -side top 
    pack $base.fra27.but28  -in .top17.fra27 -anchor center -expand 0 -fill x -side top
}

proc vTclWindow.top18 {base} {
    if {$base == ""} {
        set base .top18
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 264x144+270+154
    wm maxsize $base 785 570
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "About"
    frame $base.fra24  -borderwidth 2 -height 75 -relief groove -width 125 
    message $base.fra24.mes31  -background #eebb00 -justify center -padx 5 -pady 2  -text {ConLogV V1.1  
(c) 1999-2001 Dr. Markus Peuckert
DH1MP} -width 250      
    frame $base.fra29  -borderwidth 2 -height 75 -width 125 
    button $base.fra29.but30  -command {Window hide $widget(AboutWin)} -padx 9 -pady 3  -relief groove -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra24  -in .top18 -anchor center -expand 1 -fill both -side top 
    pack $base.fra24.mes31  -in .top18.fra24 -anchor center -expand 1 -fill both -side top 
    pack $base.fra29  -in .top18 -anchor center -expand 0 -fill x -side top 
    pack $base.fra29.but30  -in .top18.fra29 -anchor center -expand 0 -fill x -side top
}

proc vTclWindow.top19 {base} {
    if {$base == ""} {
        set base .top19
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 631x424+100+74
    wm maxsize $base 750 1200
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 1
    wm deiconify $base
    wm title $base "ConLogV"
    bind $base <Control-Key-2> {
        set ActBand "2m"
ChangeModeBand
    }
    bind $base <Control-Key-3> {
        set ActBand "23cm"
ChangeModeBand
    }
    bind $base <Control-Key-6> {
        set ActBand "6m"
ChangeModeBand
    }
    bind $base <Control-Key-7> {
        set ActBand "70cm"
ChangeModeBand
    }
    bind $base <Control-Key-a> {
        set prefmode "AM"
CheckMode [TranslateNumber $number]
    }
    bind $base <Control-Key-b> {
        set prefmode "SSB"
CheckMode [TranslateNumber $number]
    }
    bind $base <Control-Key-c> {
        set prefmode "CW"
CheckMode [TranslateNumber $number]
    }
    bind $base <Control-Key-f> {
        set prefmode "FM"
CheckMode [TranslateNumber $number]
    }
    bind $base <Control-Key-n> {
        NewLog
    }
    bind $base <Control-Key-o> {
        OpenLog
    }
    bind $base <Control-Key-q> {
        Quit
    }
    bind $base <Control-Key-r> {
        set prefmode "RTTY"
CheckMode [TranslateNumber $number]
    }
    bind $base <Control-Key-s> {
        SaveLog FALSE
	SaveOP
    }
    bind $base <Key-F1> {
        EditLineWithKey
    }
    bind $base <Key-F2> {
        set manualUTC TRUE
focus $widget(UTCEntry)
$widget(UTCEntry) selection range 0 end
    }
    frame $base.fra24 \
        -borderwidth 1 -height 75 -width 125 
    menubutton $base.fra24.men25 \
        -menu .top19.fra24.men25.01 -padx 4 -pady 3 -text File 
    menu $base.fra24.men25.01 \
        -cursor {} -tearoff 0 
    $base.fra24.men25.01 add command \
        -accelerator Ctrl+N -command NewLog -label New 
    $base.fra24.men25.01 add command \
        -accelerator Ctrl+O -command OpenLog -label Open 
    $base.fra24.men25.01 add command \
        -accelerator Ctrl+S -command {SaveLog FALSE} -label Save 
    $base.fra24.men25.01 add command \
        -command {SaveLog TRUE} -label {Save as ...} 
    $base.fra24.men25.01 add separator
    $base.fra24.men25.01 add command \
        -command {Window show .top39} -label Preferences 
    $base.fra24.men25.01 add separator
    $base.fra24.men25.01 add command \
        -accelerator Ctrl+Q -command Quit -label Quit 
    menubutton $base.fra24.men17 \
        -menu .top19.fra24.men17.m -padx 4 -pady 3 -text Band 
    menu $base.fra24.men17.m \
        -cursor {} -tearoff 0 
    $base.fra24.men17.m add radiobutton \
        -accelerator Ctrl+6 -command ChangeModeBand -label 6m -value 6m \
        -variable ActBand 
    $base.fra24.men17.m add radiobutton \
        -accelerator Ctrl+2 -command ChangeModeBand -label 2m -value 2m \
        -variable ActBand 
    $base.fra24.men17.m add radiobutton \
        -accelerator Ctrl+7 -command ChangeModeBand -label 70cm -value 70cm \
        -variable ActBand 
    $base.fra24.men17.m add radiobutton \
        -accelerator Ctrl+3 -command ChangeModeBand -label 23cm -value 23cm \
        -variable ActBand 
    $base.fra24.men17.m add radiobutton \
        -command ChangeModeBand -label 13cm -value 13cm -variable ActBand 
    $base.fra24.men17.m add radiobutton \
        -command ChangeModeBand -label 8cm -value 8cm -variable ActBand 
    $base.fra24.men17.m add radiobutton \
        -command ChangeModeBand -label 5cm -value 5cm -variable ActBand 
    $base.fra24.men17.m add radiobutton \
        -command ChangeModeBand -label 3cm -value 3cm -variable ActBand 
    $base.fra24.men17.m add radiobutton \
        -command ChangeModeBand -label 1.25cm -value 1.25cm -variable ActBand 
    $base.fra24.men17.m add radiobutton \
        -command ChangeModeBand -label 6.3mm -value 6.3mm -variable ActBand 
    $base.fra24.men17.m add radiobutton \
        -command ChangeModeBand -label 3.5mm -value 3.5mm -variable ActBand 
    $base.fra24.men17.m add radiobutton \
        -command ChangeModeBand -label 2.5mm -value 2.5mm -variable ActBand 
    $base.fra24.men17.m add radiobutton \
        -command ChangeModeBand -label 2mm -value 2mm -variable ActBand 
    $base.fra24.men17.m add radiobutton \
        -command ChangeModeBand -label 1.2mm -value 1.2mm -variable ActBand 
    menubutton $base.fra24.men21 \
        -menu .top19.fra24.men21.01 -padx 4 -pady 3 -text Mode 
    menu $base.fra24.men21.01 \
        -cursor {} -tearoff 0 
    $base.fra24.men21.01 add radiobutton \
        -accelerator Ctrl+B -command {CheckMode [TranslateNumber $number]} \
        -label SSB -value SSB -variable prefmode 
    $base.fra24.men21.01 add radiobutton \
        -accelerator Ctrl+C -command {CheckMode [TranslateNumber $number]} \
        -label CW -value CW -variable prefmode 
    $base.fra24.men21.01 add radiobutton \
        -accelerator Ctrl+F -command {CheckMode [TranslateNumber $number]} \
        -label FM -value FM -variable prefmode 
    $base.fra24.men21.01 add radiobutton \
        -accelerator Ctrl+A -command {CheckMode [TranslateNumber $number]} \
        -label AM -value AM -variable prefmode 
    $base.fra24.men21.01 add radiobutton \
        -accelerator Ctrl+R -command {CheckMode [TranslateNumber $number]} \
        -label RTTY -value RTTY -variable prefmode 
    $base.fra24.men21.01 add separator
    $base.fra24.men21.01 add radiobutton \
        -command {CheckMode [TranslateNumber $number]} -label {Nr only} \
        -value Nr -variable DOK 
    $base.fra24.men21.01 add radiobutton \
        -command {CheckMode [TranslateNumber $number]} -label {DOK only} \
        -value DOK -variable DOK 
    $base.fra24.men21.01 add radiobutton \
        -command {CheckMode [TranslateNumber $number]} -label {Nr + DOK} \
        -value NrDOK -variable DOK 
    $base.fra24.men21.01 add separator
    $base.fra24.men21.01 add checkbutton \
        -command {CheckMode [TranslateNumber $number]} -label Aurora \
        -variable Aurora 
    menubutton $base.fra24.men18 \
        -menu .top19.fra24.men18.m -padx 4 -pady 3 -text Misc 
    menu $base.fra24.men18.m \
        -cursor {} -tearoff 0 
    $base.fra24.men18.m add command \
        -command DisplayOPWin -label Operator 
    $base.fra24.men18.m add command \
        -command DisplayStatWin -label Statistic 
    $base.fra24.men18.m add command \
        -command QSOInvalid -label {Save invalid QSO} 
    $base.fra24.men18.m add command \
        -command DisplayNumberWin -label {New Number} 
    button $base.fra24.but19 \
        -command {Window show $widget(AboutWin)} -padx 9 -pady 3 -relief flat \
        -takefocus 0 -text About 
    button $base.fra24.but20 \
        -command {Window show $widget(HelpWin)} -padx 9 -pady 3 -relief flat \
        -takefocus 0 -text Help 
    frame $base.fra30 \
        -background #eebb00 -borderwidth 1 -height 41 -relief raised \
        -width 125 
    label $base.fra30.lab31 \
        -background #eebb00 -padx 0 -pady 0 -relief groove -text MyCall \
        -textvariable callLabel 
    label $base.fra30.lab32 \
        -background #eebb00 -padx 0 -pady 0 -relief groove -text {} \
        -textvariable mylocLabel 
    label $base.fra30.lab33 \
        -background #eebb00 -padx 0 -pady 0 -relief groove \
        -text {Number : 001} -textvariable numberLabel 
    label $base.fra30.lab34 \
        -background #eebb00 -padx 0 -pady 0 -relief groove \
        -text {Mode : 2m SSB} -textvariable modeLabel 
    label $base.fra30.lab35 \
        -background #eebb00 -foreground #000000 -padx 0 -pady 0 \
        -relief groove -text {} \
        -textvariable timeLabel 
    frame $base.fra36 \
        -borderwidth 2 -height 75 -relief sunken -width 125 
    frame $base.fra36.fra37 \
        -borderwidth 2 -height 75 
    label $base.fra36.fra37.lab46 \
        -borderwidth 1 -text UTC 
    entry $base.fra36.fra37.ent47 \
        -highlightcolor #c80000 -justify center -relief groove -takefocus 0 \
        -textvariable utcentry -width 6 
    bind $base.fra36.fra37.ent47 <Key-Return> {
        EvalUTC
    }
    bind $base.fra36.fra37.ent47 <Key-Tab> {
        EvalUTC
    }
    frame $base.fra36.fra42 \
        -borderwidth 2 -height 75 -width 125 
    label $base.fra36.fra42.lab48 \
        -borderwidth 1 -text Call 
    entry $base.fra36.fra42.ent49 \
        -highlightcolor #c80000 -justify center -relief groove -takefocus 0 \
        -textvariable callentry -width 14 
    bind $base.fra36.fra42.ent49 <Key-Return> {
        EvalCall
    }
    bind $base.fra36.fra42.ent49 <Key-Tab> {
        EvalCall
    }
    frame $base.fra36.fra43 \
        -borderwidth 2 -height 75 -width 125 
    label $base.fra36.fra43.lab50 \
        -borderwidth 1 -text {RST out} 
    entry $base.fra36.fra43.ent51 \
        -highlightcolor #c80000 -justify center -relief groove -takefocus 0 \
        -textvariable rstoutentry -width 7 
    bind $base.fra36.fra43.ent51 <Key-Return> {
        EvalRSTout
    }
    bind $base.fra36.fra43.ent51 <Key-Tab> {
        EvalRSTout
    }
    frame $base.fra36.fra44 \
        -borderwidth 2 -height 75 -width 125 
    label $base.fra36.fra44.lab52 \
        -borderwidth 1 -text {RST in} 
    entry $base.fra36.fra44.ent53 \
        -highlightcolor #c80000 -justify center -relief groove -takefocus 0 \
        -textvariable rstinentry -width 7 
    bind $base.fra36.fra44.ent53 <Key-Return> {
        EvalRSTin
    }
    bind $base.fra36.fra44.ent53 <Key-Tab> {
        EvalRSTin
    }
    frame $base.fra36.fra45 \
        -borderwidth 2 -height 75 -width 125 
    label $base.fra36.fra45.lab54 \
        -borderwidth 1 -text Locator 
    entry $base.fra36.fra45.ent55 \
        -highlightcolor #c80000 -justify center -relief groove -takefocus 0 \
        -textvariable locatorentry -width 7 
    bind $base.fra36.fra45.ent55 <Key-Return> {
        EvalLocator
    }
    bind $base.fra36.fra45.ent55 <Key-Tab> {
        EvalLocator
    }
    frame $base.fra38 \
        -height 75 -relief groove -width 125 
    frame $base.fra38.fra39 \
        -height 75 -relief groove -width 125 
    frame $base.fra38.fra39.fra19 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    frame $base.fra38.fra39.fra19.fra17 \
        -borderwidth 2 -height 75 -width 125 
    label $base.fra38.fra39.fra19.fra17.lab18 \
        -borderwidth 1 -text {Input : } 
    entry $base.fra38.fra39.fra19.fra17.ent19 \
        -borderwidth 1 -highlightcolor #c80000 -takefocus 1 \
        -textvariable inputentry 
    bind $base.fra38.fra39.fra19.fra17.ent19 <Key-Delete> {
        set inputentry {}
    }
    bind $base.fra38.fra39.fra19.fra17.ent19 <Key-Escape> {
        NextEntries
    }
    bind $base.fra38.fra39.fra19.fra17.ent19 <Key-Return> {
        EvalInput
    }
    frame $base.fra38.fra39.fra19.fra20 \
        -borderwidth 2 -height 75 -width 125 
    label $base.fra38.fra39.fra19.fra20.01 \
        -borderwidth 1 -justify left -text {Info : } 
    entry $base.fra38.fra39.fra19.fra20.02 \
        -cursor {} -relief flat -state disabled -takefocus 0 \
        -textvariable infoentry 
    frame $base.fra38.fra39.fra21 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    frame $base.fra38.fra39.fra21.fra23 \
        -height 75 -relief groove -width 125 
    frame $base.fra38.fra39.fra21.fra23.fra26 \
        -height 75 -relief groove -width 125 
    label $base.fra38.fra39.fra21.fra23.fra26.01 \
        -borderwidth 1 -justify left -text {Total Points :} -width 11 
    entry $base.fra38.fra39.fra21.fra23.fra26.02 \
        -borderwidth 0 -cursor {} -state disabled -takefocus 0 \
        -textvariable totalentry -width 10 
    frame $base.fra38.fra39.fra21.fra23.fra27 \
        -height 75 -relief groove -width 125 
    label $base.fra38.fra39.fra21.fra23.fra27.lab28 \
        -borderwidth 1 -justify left -text {Points/h       :} -width 11 
    entry $base.fra38.fra39.fra21.fra23.fra27.ent29 \
        -borderwidth 0 -cursor {} -state disabled -takefocus 0 \
        -textvariable pointsHRentry -width 10 
    frame $base.fra38.fra39.fra21.fra24 \
        -height 75 -relief groove -width 125 
    frame $base.fra38.fra39.fra21.fra24.fra33 \
        -height 75 -relief groove -width 125 
    label $base.fra38.fra39.fra21.fra24.fra33.lab34 \
        -borderwidth 1 -justify left -text {ODX        :} 
    entry $base.fra38.fra39.fra21.fra24.fra33.ent35 \
        -borderwidth 0 -cursor {} -state disabled -takefocus 0 \
        -textvariable ODX -width 10 
    frame $base.fra38.fra39.fra21.fra24.fra36 \
        -height 75 -relief groove -width 125 
    label $base.fra38.fra39.fra21.fra24.fra36.lab37 \
        -borderwidth 1 -justify left -padx 0 -text {km/QSO  :} 
    entry $base.fra38.fra39.fra21.fra24.fra36.ent38 \
        -borderwidth 0 -cursor {} -state disabled -takefocus 0 \
        -textvariable kmQSOentry -width 10 
    frame $base.fra38.fra39.fra21.fra25 \
        -height 75 -relief groove -width 125 
    frame $base.fra38.fra39.fra21.fra25.fra42 \
        -height 75 -relief groove -width 125 
    label $base.fra38.fra39.fra21.fra25.fra42.lab43 \
        -borderwidth 1 -justify left -text {ODX-Call :} 
    entry $base.fra38.fra39.fra21.fra25.fra42.ent44 \
        -borderwidth 0 -cursor {} -state disabled -takefocus 0 \
        -textvariable ODXCall -width 10 
    frame $base.fra38.fra39.fra21.fra25.fra45 \
        -height 75 -relief groove -width 125 
    label $base.fra38.fra39.fra21.fra25.fra45.lab46 \
        -borderwidth 1 -justify left -text {QSO's/h  :} 
    entry $base.fra38.fra39.fra21.fra25.fra45.ent47 \
        -borderwidth 0 -cursor {} -state disabled -takefocus 0 \
        -textvariable QSOHRentry -width 10 
    frame $base.fra38.fra39.fra20 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    frame $base.fra38.fra39.fra20.fra17 \
        -height 75 -relief groove -width 125 
    label $base.fra38.fra39.fra20.fra17.lab18 \
        -borderwidth 1 -text {Best QSO-Rate :} 
    entry $base.fra38.fra39.fra20.fra17.ent19 \
        -borderwidth 0 -cursor {} -relief flat -state disabled -takefocus 0 \
        -textvariable bestRateEntry -width 6 
    frame $base.fra38.fra39.fra20.fra20 \
        -height 75 -width 125 
    label $base.fra38.fra39.fra20.fra20.01 \
        -borderwidth 1 -justify left -text {Last hr QSO's : } 
    entry $base.fra38.fra39.fra20.fra20.02 \
        -borderwidth 0 -cursor {} -state disabled -takefocus 0 \
        -textvariable lastQSOentry -width 5 
    frame $base.fra38.fra39.fra20.fra21 \
        -height 75 -width 125 
    label $base.fra38.fra39.fra20.fra21.01 \
        -borderwidth 1 -justify left -text {Last hr Points : } 
    entry $base.fra38.fra39.fra20.fra21.02 \
        -borderwidth 0 -cursor {} -state disabled -takefocus 0 \
        -textvariable lastPointsentry -width 6 
    frame $base.fra38.fra23 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    canvas $base.fra38.fra23.can24 \
        -background #00cd00 -borderwidth 1 -height 68 -highlightcolor #000000 \
        -relief ridge -takefocus 0 -width 148 
    label $base.fra38.fra23.lab17 \
        -borderwidth 0 -justify left -text {km : ---    Brg : ---} \
        -textvariable bearingLabel 
    frame $base.fra37 \
        -borderwidth 2 -height 31 -width 125 
    frame $base.fra37.01 \
        -height 75 -width 100 
    label $base.fra37.01.02 \
        -borderwidth 1 -text Nr. -width 6 
    listbox $base.fra37.01.lis38 \
        -borderwidth 1 -selectbackground #eebb00 -takefocus 0 -width 6 \
        -yscrollcommand ScrollAll 
    bind $base.fra37.01.lis38 <Button-2> {
        MarkInvalidListBoxes [%W curselection]
    }
    bind $base.fra37.01.lis38 <Double-Button-1> {
        CopyLine [%W curselection]
    }
    bind $base.fra37.01.lis38 <Key-Delete> {
        MarkInvalidListBoxes [%W curselection]
    }
    bind $base.fra37.01.lis38 <Key-Escape> {
        selection clear
focus $widget(InputEntry)
    }
    bind $base.fra37.01.lis38 <Key-Return> {
        CopyLine [%W curselection]
    }
    frame $base.fra37.03 \
        -height 75 -width 125 
    label $base.fra37.03.04 \
        -borderwidth 1 -text UTC -width 6 
    listbox $base.fra37.03.lis39 \
        -borderwidth 1 -selectmode single -takefocus 0 -width 6 
    bind $base.fra37.03.lis39 <Button-2> {
        MarkInvalidListBoxes [%W curselection]
    }
    bind $base.fra37.03.lis39 <Double-Button-1> {
        CopyLine [%W curselection]
    }
    frame $base.fra37.05 \
        -height 75 -width 125 
    label $base.fra37.05.06 \
        -borderwidth 1 -text Call -width 16 
    listbox $base.fra37.05.lis40 \
        -borderwidth 1 -selectmode single -takefocus 0 -width 16 
    bind $base.fra37.05.lis40 <Button-2> {
        MarkInvalidListBoxes [%W curselection]
    }
    bind $base.fra37.05.lis40 <Double-Button-1> {
        CopyLine [%W curselection]
    }
    frame $base.fra37.07 \
        -height 75 -width 125 
    label $base.fra37.07.08 \
        -borderwidth 1 -text {RST out} -width 8 
    listbox $base.fra37.07.lis41 \
        -borderwidth 1 -selectmode single -takefocus 0 -width 10 
    bind $base.fra37.07.lis41 <Button-2> {
        MarkInvalidListBoxes [%W curselection]
    }
    bind $base.fra37.07.lis41 <Double-Button-1> {
        CopyLine [%W curselection]
    }
    frame $base.fra37.09 \
        -height 75 -relief groove -width 125 
    label $base.fra37.09.010 \
        -borderwidth 1 -text {RST in} -width 8 
    listbox $base.fra37.09.lis42 \
        -borderwidth 1 -selectmode single -takefocus 0 -width 10 
    bind $base.fra37.09.lis42 <Button-2> {
        MarkInvalidListBoxes [%W curselection]
    }
    bind $base.fra37.09.lis42 <Double-Button-1> {
        CopyLine [%W curselection]
    }
    frame $base.fra37.011 \
        -height 75 -relief groove -width 125 
    label $base.fra37.011.012 \
        -borderwidth 1 -text Locator -width 10 
    listbox $base.fra37.011.lis43 \
        -borderwidth 1 -selectmode single -takefocus 0 -width 10 
    bind $base.fra37.011.lis43 <Button-2> {
        MarkInvalidListBoxes [%W curselection]
    }
    bind $base.fra37.011.lis43 <Double-Button-1> {
        CopyLine [%W curselection]
    }
    frame $base.fra37.fra37 \
        -height 75 -width 125 
    label $base.fra37.fra37.lab38 \
        -borderwidth 1 -text Mode 
    listbox $base.fra37.fra37.lis39 \
        -borderwidth 1 -selectmode single -takefocus 0 -width 8 
    bind $base.fra37.fra37.lis39 <Button-2> {
        MarkInvalidListBoxes [%W curselection]
    }
    bind $base.fra37.fra37.lis39 <Double-Button-1> {
        CopyLine [%W curselection]
    }
    frame $base.fra37.fra41 \
        -height 75 -relief groove -width 125 
    label $base.fra37.fra41.01 \
        -borderwidth 1 -text Points -width 8 
    listbox $base.fra37.fra41.02 \
        -borderwidth 1 -selectmode single -takefocus 0 -width 8 
    bind $base.fra37.fra41.02 <Button-2> {
        MarkInvalidListBoxes [%W curselection]
    }
    bind $base.fra37.fra41.02 <Double-Button-1> {
        CopyLine [%W curselection]
    }
    frame $base.fra37.fra42 \
        -height 75 -relief groove -width 125 
    label $base.fra37.fra42.01 \
        -borderwidth 1 -text Bearing -width 6 
    frame $base.fra37.fra42.02 \
        -height 75 -width 125 
    listbox $base.fra37.fra42.02.03 \
        -borderwidth 1 -height 0 -selectmode single -takefocus 0 -width 6 
    bind $base.fra37.fra42.02.03 <Button-2> {
        MarkInvalidListBoxes [%W curselection]
    }
    bind $base.fra37.fra42.02.03 <Double-Button-1> {
        CopyLine [%W curselection]
    }
    scrollbar $base.fra37.fra42.02.scr43 \
        -background grey77 -borderwidth 1 -command ScrollListBoxes \
        -orient vert -takefocus 0 -width 10 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra24 \
        -in .top19 -anchor center -expand 0 -fill x -side top 
    pack $base.fra24.men25 \
        -in .top19.fra24 -anchor center -expand 0 -fill none -side left 
    pack $base.fra24.men17 \
        -in .top19.fra24 -anchor center -expand 0 -fill none -side left 
    pack $base.fra24.men21 \
        -in .top19.fra24 -anchor center -expand 0 -fill none -side left 
    pack $base.fra24.men18 \
        -in .top19.fra24 -anchor center -expand 0 -fill none -side left 
    pack $base.fra24.but19 \
        -in .top19.fra24 -anchor center -expand 0 -fill none -side right 
    pack $base.fra24.but20 \
        -in .top19.fra24 -anchor center -expand 0 -fill none -side right 
    pack $base.fra30 \
        -in .top19 -anchor center -expand 0 -fill x -ipady 5 -side top 
    pack $base.fra30.lab31 \
        -in .top19.fra30 -anchor center -expand 0 -fill none -ipadx 10 \
        -ipady 3 -padx 5 -side left 
    pack $base.fra30.lab32 \
        -in .top19.fra30 -anchor center -expand 1 -fill none -ipadx 10 \
        -ipady 3 -side left 
    pack $base.fra30.lab33 \
        -in .top19.fra30 -anchor center -expand 1 -fill none -ipadx 5 \
        -ipady 3 -side left 
    pack $base.fra30.lab34 \
        -in .top19.fra30 -anchor center -expand 1 -fill none -ipadx 5 \
        -ipady 3 -side left 
    pack $base.fra30.lab35 \
        -in .top19.fra30 -anchor center -expand 0 -fill none -ipadx 5 \
        -ipady 3 -padx 5 -side right 
    pack $base.fra36 \
        -in .top19 -anchor center -expand 0 -fill x -pady 2 -side top 
    pack $base.fra36.fra37 \
        -in .top19.fra36 -anchor center -expand 0 -fill x -side left 
    pack $base.fra36.fra37.lab46 \
        -in .top19.fra36.fra37 -anchor center -expand 0 -fill x -side top 
    pack $base.fra36.fra37.ent47 \
        -in .top19.fra36.fra37 -anchor center -expand 1 -fill x -side top 
    pack $base.fra36.fra42 \
        -in .top19.fra36 -anchor center -expand 1 -fill x -side left 
    pack $base.fra36.fra42.lab48 \
        -in .top19.fra36.fra42 -anchor center -expand 0 -fill x -side top 
    pack $base.fra36.fra42.ent49 \
        -in .top19.fra36.fra42 -anchor center -expand 0 -fill x -side top 
    pack $base.fra36.fra43 \
        -in .top19.fra36 -anchor center -expand 1 -fill x -side left 
    pack $base.fra36.fra43.lab50 \
        -in .top19.fra36.fra43 -anchor center -expand 0 -fill x -side top 
    pack $base.fra36.fra43.ent51 \
        -in .top19.fra36.fra43 -anchor center -expand 0 -fill x -side top 
    pack $base.fra36.fra44 \
        -in .top19.fra36 -anchor center -expand 1 -fill x -side left 
    pack $base.fra36.fra44.lab52 \
        -in .top19.fra36.fra44 -anchor center -expand 0 -fill x -side top 
    pack $base.fra36.fra44.ent53 \
        -in .top19.fra36.fra44 -anchor center -expand 0 -fill x -side top 
    pack $base.fra36.fra45 \
        -in .top19.fra36 -anchor center -expand 1 -fill x -side right 
    pack $base.fra36.fra45.lab54 \
        -in .top19.fra36.fra45 -anchor center -expand 0 -fill x -side top 
    pack $base.fra36.fra45.ent55 \
        -in .top19.fra36.fra45 -anchor center -expand 0 -fill x -side top 
    pack $base.fra38 \
        -in .top19 -anchor center -expand 0 -fill x -side top 
    pack $base.fra38.fra39 \
        -in .top19.fra38 -anchor center -expand 1 -fill x -side left 
    pack $base.fra38.fra39.fra19 \
        -in .top19.fra38.fra39 -anchor center -expand 0 -fill x -side top 
    pack $base.fra38.fra39.fra19.fra17 \
        -in .top19.fra38.fra39.fra19 -anchor center -expand 0 -fill none \
        -side left 
    pack $base.fra38.fra39.fra19.fra17.lab18 \
        -in .top19.fra38.fra39.fra19.fra17 -anchor center -expand 0 \
        -fill none -side left 
    pack $base.fra38.fra39.fra19.fra17.ent19 \
        -in .top19.fra38.fra39.fra19.fra17 -anchor center -expand 1 -fill x \
        -side left 
    pack $base.fra38.fra39.fra19.fra20 \
        -in .top19.fra38.fra39.fra19 -anchor center -expand 1 -fill x \
        -side left 
    pack $base.fra38.fra39.fra19.fra20.01 \
        -in .top19.fra38.fra39.fra19.fra20 -anchor center -expand 0 -fill x \
        -side left 
    pack $base.fra38.fra39.fra19.fra20.02 \
        -in .top19.fra38.fra39.fra19.fra20 -anchor center -expand 1 -fill x \
        -side left 
    pack $base.fra38.fra39.fra21 \
        -in .top19.fra38.fra39 -anchor center -expand 1 -fill x -side top 
    pack $base.fra38.fra39.fra21.fra23 \
        -in .top19.fra38.fra39.fra21 -anchor center -expand 1 -fill x \
        -side left 
    pack $base.fra38.fra39.fra21.fra23.fra26 \
        -in .top19.fra38.fra39.fra21.fra23 -anchor center -expand 0 -fill x \
        -side top 
    pack $base.fra38.fra39.fra21.fra23.fra26.01 \
        -in .top19.fra38.fra39.fra21.fra23.fra26 -anchor center -expand 0 \
        -fill none -ipadx 2 -side left 
    pack $base.fra38.fra39.fra21.fra23.fra26.02 \
        -in .top19.fra38.fra39.fra21.fra23.fra26 -anchor center -expand 1 \
        -fill x -side right 
    pack $base.fra38.fra39.fra21.fra23.fra27 \
        -in .top19.fra38.fra39.fra21.fra23 -anchor center -expand 0 -fill x \
        -side top 
    pack $base.fra38.fra39.fra21.fra23.fra27.lab28 \
        -in .top19.fra38.fra39.fra21.fra23.fra27 -anchor center -expand 0 \
        -fill none -ipadx 2 -side left 
    pack $base.fra38.fra39.fra21.fra23.fra27.ent29 \
        -in .top19.fra38.fra39.fra21.fra23.fra27 -anchor center -expand 1 \
        -fill x -side right 
    pack $base.fra38.fra39.fra21.fra24 \
        -in .top19.fra38.fra39.fra21 -anchor center -expand 1 -fill x \
        -side left 
    pack $base.fra38.fra39.fra21.fra24.fra33 \
        -in .top19.fra38.fra39.fra21.fra24 -anchor center -expand 0 -fill x \
        -side top 
    pack $base.fra38.fra39.fra21.fra24.fra33.lab34 \
        -in .top19.fra38.fra39.fra21.fra24.fra33 -anchor center -expand 0 \
        -fill none -side left 
    pack $base.fra38.fra39.fra21.fra24.fra33.ent35 \
        -in .top19.fra38.fra39.fra21.fra24.fra33 -anchor center -expand 1 \
        -fill x -side right 
    pack $base.fra38.fra39.fra21.fra24.fra36 \
        -in .top19.fra38.fra39.fra21.fra24 -anchor center -expand 0 -fill x \
        -side top 
    pack $base.fra38.fra39.fra21.fra24.fra36.lab37 \
        -in .top19.fra38.fra39.fra21.fra24.fra36 -anchor center -expand 0 \
        -fill none -side left 
    pack $base.fra38.fra39.fra21.fra24.fra36.ent38 \
        -in .top19.fra38.fra39.fra21.fra24.fra36 -anchor center -expand 1 \
        -fill x -side right 
    pack $base.fra38.fra39.fra21.fra25 \
        -in .top19.fra38.fra39.fra21 -anchor center -expand 1 -fill x \
        -side left 
    pack $base.fra38.fra39.fra21.fra25.fra42 \
        -in .top19.fra38.fra39.fra21.fra25 -anchor center -expand 0 -fill x \
        -side top 
    pack $base.fra38.fra39.fra21.fra25.fra42.lab43 \
        -in .top19.fra38.fra39.fra21.fra25.fra42 -anchor center -expand 0 \
        -fill none -side left 
    pack $base.fra38.fra39.fra21.fra25.fra42.ent44 \
        -in .top19.fra38.fra39.fra21.fra25.fra42 -anchor center -expand 1 \
        -fill x -side right 
    pack $base.fra38.fra39.fra21.fra25.fra45 \
        -in .top19.fra38.fra39.fra21.fra25 -anchor center -expand 0 -fill x \
        -side top 
    pack $base.fra38.fra39.fra21.fra25.fra45.lab46 \
        -in .top19.fra38.fra39.fra21.fra25.fra45 -anchor center -expand 0 \
        -fill none -ipadx 1 -side left 
    pack $base.fra38.fra39.fra21.fra25.fra45.ent47 \
        -in .top19.fra38.fra39.fra21.fra25.fra45 -anchor center -expand 1 \
        -fill x -side right 
    pack $base.fra38.fra39.fra20 \
        -in .top19.fra38.fra39 -anchor center -expand 0 -fill x -side top 
    pack $base.fra38.fra39.fra20.fra17 \
        -in .top19.fra38.fra39.fra20 -anchor center -expand 1 -fill x \
        -side left 
    pack $base.fra38.fra39.fra20.fra17.lab18 \
        -in .top19.fra38.fra39.fra20.fra17 -anchor center -expand 0 \
        -fill none -side left 
    pack $base.fra38.fra39.fra20.fra17.ent19 \
        -in .top19.fra38.fra39.fra20.fra17 -anchor center -expand 1 -fill x \
        -side right 
    pack $base.fra38.fra39.fra20.fra20 \
        -in .top19.fra38.fra39.fra20 -anchor center -expand 1 -fill x \
        -side left 
    pack $base.fra38.fra39.fra20.fra20.01 \
        -in .top19.fra38.fra39.fra20.fra20 -anchor center -expand 0 \
        -fill none -side left 
    pack $base.fra38.fra39.fra20.fra20.02 \
        -in .top19.fra38.fra39.fra20.fra20 -anchor center -expand 1 -fill x \
        -side right 
    pack $base.fra38.fra39.fra20.fra21 \
        -in .top19.fra38.fra39.fra20 -anchor center -expand 1 -fill x \
        -side left 
    pack $base.fra38.fra39.fra20.fra21.01 \
        -in .top19.fra38.fra39.fra20.fra21 -anchor center -expand 0 \
        -fill none -side left 
    pack $base.fra38.fra39.fra20.fra21.02 \
        -in .top19.fra38.fra39.fra20.fra21 -anchor center -expand 1 -fill x \
        -side right 
    pack $base.fra38.fra23 \
        -in .top19.fra38 -anchor center -expand 0 -fill y -side right 
    pack $base.fra38.fra23.can24 \
        -in .top19.fra38.fra23 -anchor center -expand 0 -fill none -side top 
    pack $base.fra38.fra23.lab17 \
        -in .top19.fra38.fra23 -anchor center -expand 0 -fill x -side top 
    pack $base.fra37 \
        -in .top19 -anchor center -expand 1 -fill both -side top 
    pack $base.fra37.01 \
        -in .top19.fra37 -anchor center -expand 0 -fill y -side left 
    pack $base.fra37.01.02 \
        -in .top19.fra37.01 -anchor center -expand 0 -fill x -padx 1 \
        -side top 
    pack $base.fra37.01.lis38 \
        -in .top19.fra37.01 -anchor center -expand 1 -fill y -side top 
    pack $base.fra37.03 \
        -in .top19.fra37 -anchor center -expand 0 -fill y -side left 
    pack $base.fra37.03.04 \
        -in .top19.fra37.03 -anchor center -expand 0 -fill x -padx 1 \
        -side top 
    pack $base.fra37.03.lis39 \
        -in .top19.fra37.03 -anchor center -expand 1 -fill y -side top 
    pack $base.fra37.05 \
        -in .top19.fra37 -anchor center -expand 0 -fill y -side left 
    pack $base.fra37.05.06 \
        -in .top19.fra37.05 -anchor center -expand 0 -fill x -padx 1 \
        -side top 
    pack $base.fra37.05.lis40 \
        -in .top19.fra37.05 -anchor center -expand 1 -fill y -side top 
    pack $base.fra37.07 \
        -in .top19.fra37 -anchor center -expand 0 -fill y -side left 
    pack $base.fra37.07.08 \
        -in .top19.fra37.07 -anchor center -expand 0 -fill x -padx 1 \
        -side top 
    pack $base.fra37.07.lis41 \
        -in .top19.fra37.07 -anchor center -expand 1 -fill y -side top 
    pack $base.fra37.09 \
        -in .top19.fra37 -anchor center -expand 0 -fill y -side left 
    pack $base.fra37.09.010 \
        -in .top19.fra37.09 -anchor center -expand 0 -fill x -padx 1 \
        -side top 
    pack $base.fra37.09.lis42 \
        -in .top19.fra37.09 -anchor center -expand 1 -fill y -side top 
    pack $base.fra37.011 \
        -in .top19.fra37 -anchor center -expand 0 -fill y -side left 
    pack $base.fra37.011.012 \
        -in .top19.fra37.011 -anchor center -expand 0 -fill x -padx 1 \
        -side top 
    pack $base.fra37.011.lis43 \
        -in .top19.fra37.011 -anchor center -expand 1 -fill y -side top 
    pack $base.fra37.fra37 \
        -in .top19.fra37 -anchor center -expand 0 -fill y -side left 
    pack $base.fra37.fra37.lab38 \
        -in .top19.fra37.fra37 -anchor center -expand 0 -fill x -side top 
    pack $base.fra37.fra37.lis39 \
        -in .top19.fra37.fra37 -anchor center -expand 1 -fill y -side top 
    pack $base.fra37.fra41 \
        -in .top19.fra37 -anchor center -expand 0 -fill y -side left 
    pack $base.fra37.fra41.01 \
        -in .top19.fra37.fra41 -anchor center -expand 0 -fill x -padx 1 \
        -side top 
    pack $base.fra37.fra41.02 \
        -in .top19.fra37.fra41 -anchor center -expand 1 -fill y -side top 
    pack $base.fra37.fra42 \
        -in .top19.fra37 -anchor center -expand 0 -fill y -side left 
    pack $base.fra37.fra42.01 \
        -in .top19.fra37.fra42 -anchor center -expand 0 -fill x -side top 
    pack $base.fra37.fra42.02 \
        -in .top19.fra37.fra42 -anchor center -expand 1 -fill y -side top 
    pack $base.fra37.fra42.02.03 \
        -in .top19.fra37.fra42.02 -anchor center -expand 0 -fill y -side left 
    pack $base.fra37.fra42.02.scr43 \
        -in .top19.fra37.fra42.02 -anchor center -expand 0 -fill y -side left 
}

proc vTclWindow.top20 {base} {
    if {$base == ""} {
        set base .top20
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 432x460+149+15
    wm maxsize $base 785 570
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "Help"
    frame $base.fra21  -borderwidth 2 -height 75 -relief groove -width 125 
    message $base.fra21.mes24  -background #eb0 -borderwidth 0 -padx 5 -pady 2  -text {    Key-Bindings:

    F1		--> Put Inputfocus on first Listbox
			Move around with Cursor-Keys and/or
			Up/Down-Keys
			Press "Return" to edit selected entry
			Press "Del" to mark entry as invalid
    F2		--> Put Inputfocus on UTC-EntryWidget
    F10		--> Enter Menu
    ESC		--> Delete all Entrywidgets
    DEL		--> Delete Input-EntryWidget
    Tab		--> Evaluate entry (Not Input-Entry)
    Return	--> Evaluate the contents of the EntryWidget
			and/or move the InputCursor to the
			Input-EntryWidget    

    DoubleClick	--> Select entry in Listbox for editing
    
    ClickLeft and ClickMiddle in Listbox
    		--> Mark entry as invalid

    Special characters:

    	#	--> will be substituted with "/P"
    	+	--> will be substituted with "/MM"
    	-	--> will be substituted with "/M"
    	<	--> will be substituted with "/AM"
} 
    frame $base.fra22  -borderwidth 2 -height 75 -width 125 
    button $base.fra22.but23  -command {Window hide $widget(HelpWin)} -padx 9 -pady 3  -relief groove -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra21  -in .top20 -anchor center -expand 1 -fill both -side top 
    pack $base.fra21.mes24  -in .top20.fra21 -anchor center -expand 1 -fill both -side top 
    pack $base.fra22  -in .top20 -anchor center -expand 0 -fill x -side top 
    pack $base.fra22.but23  -in .top20.fra22 -anchor center -expand 0 -fill x -side top
}

proc vTclWindow.top21 {base} {
    if {$base == ""} {
        set base .top21
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 308x84+304+208
    wm maxsize $base 1585 1170
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Enter new Number"
    frame $base.fra22  -borderwidth 1 -height 75 -relief groove -width 125 
    label $base.fra22.lab27  -borderwidth 1 -text {Number : } 
    entry $base.fra22.ent28  -borderwidth 1 -textvariable numberentry 
    bind $base.fra22.ent28 <Key-Escape> {
        Window hide $widget(NumberWin)
    }
    bind $base.fra22.ent28 <Key-Return> {
        NewNumber
    }
    frame $base.fra23  -borderwidth 1 -height 75 -relief groove -width 125 
    button $base.fra23.but25  -borderwidth 1 -command NewNumber -padx 9 -pady 3 -text OK 
    button $base.fra23.but26  -borderwidth 1 -command {Window hide $widget(NumberWin)} -padx 9  -pady 3 -text Cancel 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra22  -in .top21 -anchor center -expand 1 -fill both -side top 
    pack $base.fra22.lab27  -in .top21.fra22 -anchor center -expand 0 -fill none -side left 
    pack $base.fra22.ent28  -in .top21.fra22 -anchor center -expand 1 -fill x -side left 
    pack $base.fra23  -in .top21 -anchor center -expand 0 -fill x -side top 
    pack $base.fra23.but25  -in .top21.fra23 -anchor center -expand 1 -fill none -side left 
    pack $base.fra23.but26  -in .top21.fra23 -anchor center -expand 1 -fill none -side right
}

proc vTclWindow.top26 {base} {
    if {$base == ""} {
        set base .top26
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 264x144+282+156
    wm maxsize $base 785 570
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Alert"
    frame $base.01  -borderwidth 2 -height 75 -relief groove -width 125 
    message $base.01.02  -background #eebb00 -justify center -padx 5 -pady 2  -text {There is something wrong with 
File-Manipulation or with your
Inputs in the Preferences!
------------------------
Sorry for any inconvenience!}  -width 250 
    frame $base.03  -borderwidth 2 -height 75 -width 125 
    button $base.03.04  -command {Window hide $widget(AboutWin)} -padx 9 -pady 3  -relief groove -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.01  -in .top26 -anchor center -expand 1 -fill both -side top 
    pack $base.01.02  -in .top26.01 -anchor center -expand 1 -fill both -side top 
    pack $base.03  -in .top26 -anchor center -expand 0 -fill x -side top 
    pack $base.03.04  -in .top26.03 -anchor center -expand 0 -fill x -side top
}

proc vTclWindow.top31 {base} {
    if {$base == ""} {
        set base .top31
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 308x84+323+221
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Enter new Operator"
    frame $base.fra32  -borderwidth 1 -height 75 -relief groove -width 125 
    frame $base.fra32.fra34  -height 75 -relief groove -width 125 
    label $base.fra32.fra34.lab36  -borderwidth 1 -text {Operator : } 
    frame $base.fra32.fra35  -height 75 -relief groove -width 125 
    entry $base.fra32.fra35.ent37  -borderwidth 1 -takefocus 1 -textvariable Operator 
    bind $base.fra32.fra35.ent37 <Key-Escape> {
        Window hide $widget(OperatorWin)
    }
    bind $base.fra32.fra35.ent37 <Key-Return> {
        AddOP
SaveOP
    }
    frame $base.fra33  -borderwidth 1 -height 75 -relief groove -width 125 
    button $base.fra33.but38  -borderwidth 1 -command {AddOP
SaveOP} -padx 9 -pady 3 -text OK 
    button $base.fra33.but39  -borderwidth 1 -command {Window hide $widget(OperatorWin)} -padx 9  -pady 3 -text Cancel 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra32  -in .top31 -anchor center -expand 1 -fill both -side top 
    pack $base.fra32.fra34  -in .top31.fra32 -anchor center -expand 0 -fill none -side left 
    pack $base.fra32.fra34.lab36  -in .top31.fra32.fra34 -anchor center -expand 0 -fill none -side top 
    pack $base.fra32.fra35  -in .top31.fra32 -anchor center -expand 1 -fill x -side left 
    pack $base.fra32.fra35.ent37  -in .top31.fra32.fra35 -anchor center -expand 1 -fill x -side left 
    pack $base.fra33  -in .top31 -anchor center -expand 0 -fill x -side top 
    pack $base.fra33.but38  -in .top31.fra33 -anchor center -expand 1 -fill none -side left 
    pack $base.fra33.but39  -in .top31.fra33 -anchor center -expand 1 -fill none -side left
}

proc vTclWindow.top39 {base} {
    if {$base == ""} {
        set base .top39
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 310x515+287+86
    wm maxsize $base 1137 834
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 1
    wm title $base "Preferences"
    frame $base.fra65  -borderwidth 1 -height 75 -relief raised -width 125 
    frame $base.fra65.fra66  -height 75 -width 125 
    label $base.fra65.fra66.01  -anchor w -borderwidth 1 -text {Operator              :} 
    label $base.fra65.fra66.02  -anchor w -borderwidth 1 -text {QTH-Locator       :} 
    label $base.fra65.fra66.lab19  -anchor w -borderwidth 1 -text {DOK                    :} 
    label $base.fra65.fra66.lab21  -anchor w -borderwidth 1 -text {Logfile Path          :} 
    label $base.fra65.fra66.lab22  -anchor w -borderwidth 1 -text {AutoSave             :} 
    label $base.fra65.fra66.lab23  -anchor w -borderwidth 1 -text {Ant-Angle 6m       :} 
    label $base.fra65.fra66.lab17  -anchor w -borderwidth 1 -text {Ant-Angle 2m       :} 
    label $base.fra65.fra66.lab18  -anchor w -borderwidth 1 -text {Ant-Angle 70cm    :} 
    label $base.fra65.fra66.lab20  -anchor w -borderwidth 1 -text {Ant-Angle 23cm    :} 
    label $base.fra65.fra66.lab25  -anchor w -borderwidth 1 -text {Ant-Angle 13cm    :} 
    label $base.fra65.fra66.lab26  -anchor w -borderwidth 1 -text {Ant-Angle 8cm      :} 
    label $base.fra65.fra66.lab27  -anchor w -borderwidth 1 -text {Ant-Angle 5cm      :} 
    label $base.fra65.fra66.lab28  -anchor w -borderwidth 1 -text {Ant-Angle 3cm      :} 
    label $base.fra65.fra66.lab29  -anchor w -borderwidth 1 -text {Ant-Angle 1.25cm :} 
    label $base.fra65.fra66.lab30  -anchor w -borderwidth 1 -text {Ant-Angle 6.3mm  :} 
    label $base.fra65.fra66.lab31  -anchor w -borderwidth 1 -text {Ant-Angle 3.5mm  :} 
    label $base.fra65.fra66.lab32  -anchor w -borderwidth 1 -text {Ant-Angle 2.5mm  :} 
    label $base.fra65.fra66.lab33  -anchor w -borderwidth 1 -text {Ant-Angle 2mm     :} 
    label $base.fra65.fra66.lab34  -anchor w -borderwidth 1 -text {Ant-Angle 1.2mm  :} 
    label $base.fra65.fra66.lab45  -anchor w -borderwidth 1 -text {BandChange      :} 
    frame $base.fra65.fra67  -height 75 -width 125 
    entry $base.fra65.fra67.01  -borderwidth 1 -textvariable prefmycall 
    bind $base.fra65.fra67.01 <Key-Return> {
        set prefmycall [string toupper $prefmycall]
    }
    bind $base.fra65.fra67.01 <Key-Tab> {
        set prefmycall [string toupper $prefmycall]
    }
    entry $base.fra65.fra67.02  -borderwidth 1 -textvariable prefmyloc 
    bind $base.fra65.fra67.02 <Key-Return> {
        set prefmyloc [string toupper $prefmyloc]
    }
    bind $base.fra65.fra67.02 <Key-Tab> {
        set prefmyloc [string toupper $prefmyloc]
    }
    entry $base.fra65.fra67.ent25  -borderwidth 1 -exportselection 0 -textvariable prefDOK 
    bind $base.fra65.fra67.ent25 <Key-Return> {
        set prefDOK [string toupper $prefDOK]
    }
    bind $base.fra65.fra67.ent25 <Key-Tab> {
        set prefDOK [string toupper $prefDOK]
    }
    entry $base.fra65.fra67.ent26  -borderwidth 1 -exportselection 0 -textvariable preflogpath 
    entry $base.fra65.fra67.ent27  -borderwidth 1 -exportselection 0 -textvariable prefSaveDelay 
    entry $base.fra65.fra67.ent20  -borderwidth 1 -textvariable prefAntExt6 
    entry $base.fra65.fra67.ent21  -borderwidth 1 -textvariable prefAntExt2 
    entry $base.fra65.fra67.ent22  -borderwidth 1 -textvariable prefAntExt70 
    entry $base.fra65.fra67.ent23  -borderwidth 1 -textvariable prefAntExt23 
    entry $base.fra65.fra67.ent35  -borderwidth 1 -textvariable prefAntExt13 
    entry $base.fra65.fra67.ent36  -borderwidth 1 -textvariable prefAntExt8 
    entry $base.fra65.fra67.ent37  -borderwidth 1 -textvariable prefAntExt5 
    entry $base.fra65.fra67.ent38  -borderwidth 1 -textvariable prefAntExt3 
    entry $base.fra65.fra67.ent39  -borderwidth 1 -textvariable prefAntExt125 
    entry $base.fra65.fra67.ent40  -borderwidth 1 -textvariable prefAntExt63 
    entry $base.fra65.fra67.ent41  -borderwidth 1 -textvariable prefAntExt35 
    entry $base.fra65.fra67.ent42  -borderwidth 1 -textvariable prefAntExt25 
    entry $base.fra65.fra67.ent43  -borderwidth 1 -textvariable prefAntExt2mm 
    entry $base.fra65.fra67.ent44  -borderwidth 1 -textvariable prefAntExt12 
    entry $base.fra65.fra67.ent46  -borderwidth 1 -exportselection 0 -textvariable prefBandChange 
    frame $base.fra68  -borderwidth 1 -height 75 -relief raised -width 125 
    frame $base.fra68.02  -height 75 -width 125 
    label $base.fra68.02.lab18  -borderwidth 1 -text {Mode : } 
    menubutton $base.fra68.02.men19  -indicatoron 1 -menu .top39.fra68.02.men19.m -padx 4 -pady 3 -text 2m  -textvariable ActBand 
    menu $base.fra68.02.men19.m  -cursor {} -tearoff 0 
    $base.fra68.02.men19.m add radiobutton  -label 6m -value 6m -variable ActBand 
    $base.fra68.02.men19.m add radiobutton  -label 2m -value 2m -variable ActBand 
    $base.fra68.02.men19.m add radiobutton  -label 70cm -value 70cm -variable ActBand 
    $base.fra68.02.men19.m add radiobutton  -label 23cm -value 23cm -variable ActBand 
    menubutton $base.fra68.02.men20  -indicatoron 1 -menu .top39.fra68.02.men20.01 -padx 4 -pady 3  -text SSB -textvariable prefmode 
    menu $base.fra68.02.men20.01  -cursor {} -tearoff 0 
    $base.fra68.02.men20.01 add radiobutton  -label SSB -value SSB -variable prefmode 
    $base.fra68.02.men20.01 add radiobutton  -label CW -value CW -variable prefmode 
    $base.fra68.02.men20.01 add radiobutton  -label FM -value FM -variable prefmode 
    $base.fra68.02.men20.01 add radiobutton  -label AM -value AM -variable prefmode 
    $base.fra68.02.men20.01 add radiobutton  -label RTTY -value RTTY -variable prefmode 
    frame $base.fra69  -borderwidth 1 -height 75 -relief sunken -width 125 
    button $base.fra69.01  -borderwidth 1 -command SavePrefs -padx 9 -pady 3 -takefocus 0  -text Save 
    button $base.fra69.02  -borderwidth 1 -command {Window hide $widget(PrefWin)} -padx 9  -pady 3 -takefocus 0 -text Cancel 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra65  -in .top39 -anchor center -expand 0 -fill x -side top 
    pack $base.fra65.fra66  -in .top39.fra65 -anchor center -expand 0 -fill both -side left 
    pack $base.fra65.fra66.01  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.02  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab19  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab21  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab22  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab23  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab17  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab18  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab20  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab25  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab26  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab27  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab28  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab29  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab30  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab31  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab32  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab33  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab34  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra66.lab45  -in .top39.fra65.fra66 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67  -in .top39.fra65 -anchor center -expand 1 -fill x -side left 
    pack $base.fra65.fra67.01  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.02  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent25  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent26  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent27  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent20  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent21  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent22  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent23  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent35  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent36  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent37  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent38  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent39  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent40  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent41  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent42  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent43  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent44  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra65.fra67.ent46  -in .top39.fra65.fra67 -anchor center -expand 1 -fill x -side top 
    pack $base.fra68  -in .top39 -anchor center -expand 0 -fill x -pady 5 -side top 
    pack $base.fra68.02  -in .top39.fra68 -anchor center -expand 0 -fill x -side left 
    pack $base.fra68.02.lab18  -in .top39.fra68.02 -anchor center -expand 0 -fill none -side left 
    pack $base.fra68.02.men19  -in .top39.fra68.02 -anchor center -expand 0 -fill none -side left 
    pack $base.fra68.02.men20  -in .top39.fra68.02 -anchor center -expand 0 -fill none -side left 
    pack $base.fra69  -in .top39 -anchor center -expand 0 -fill x -pady 3 -side top 
    pack $base.fra69.01  -in .top39.fra69 -anchor center -expand 1 -fill none -side left 
    pack $base.fra69.02  -in .top39.fra69 -anchor center -expand 1 -fill none -side left
}

Window show .
Window show .top19

main $argc $argv
